# IRTools

[![Build Status](https://travis-ci.org/FluxML/IRTools.jl.svg?branch=master)](https://travis-ci.org/FluxML/IRTools.jl)
[![Dev Docs](https://img.shields.io/badge/docs-dev-blue.svg)](https://fluxml.github.io/IRTools.jl/latest/)
[![Coverage](https://codecov.io/gh/FluxML/IRTools.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/FluxML/IRTools.jl)

IRTools aims to provide a simple and flexible IR format, expressive enough to work with both lowered and typed Julia code, as well as external IRs. It can be used with Julia metaprogramming tools such as [Cassette](https://github.com/jrevels/Cassette.jl).

```julia
julia> using IRTools

julia> function pow(x, n) # A simple Julia function
         r = 1
         while n > 0
           n -= 1
           r *= x
         end
         return r
       end

julia> ir = @code_ir pow(1, 1) # Get its IR
1: (%1, %2, %3)
  br 2 (%3, 1)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
3:
  %7 = %4 - 1
  %8 = %5 * %2
  br 2 (%7, %8)
4:
  return %5

julia> using IRTools: var, xcall

julia> ir[var(8)] = xcall(:+, var(5), var(2)) # Tweak it
:(%5 + %2)

julia> ir
1: (%1, %2, %3)
  br 2 (%3, 1)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
3:
  %7 = %4 - 1
  %8 = %5 + %2
  br 2 (%7, %8)
4:
  return %5

julia> f = IRTools.func(ir); # Turn the new IR into a lambda

julia> f(nothing, 10, 5)
51

julia> @code_llvm f(nothing, 10, 5)
define i64 @"julia_##399_17438"(i64, i64) {
top:
     %2 = icmp slt i64 %1, 1
     %3 = mul i64 %1, %0
     %4 = add i64 %3, 1
     %value_phi1.lcssa = select i1 %2, i64 1, i64 %4
    ret i64 %value_phi1.lcssa
}
```

using Base: invokelatest

dummy() = return
const dummy_m = which(dummy, Tuple{})

function build_codeinfo(ir::IR)
  ir = copy(ir)
  ci = Base.uncompressed_ir(dummy_m)
  ci.inlineable = true
  for arg in arguments(ir)
    isnothing(ci.slottypes) && (ci.slottypes = Any[])
    push!(ci.slottypes, Type)
    push!(ci.slotnames, Symbol(""))
    push!(ci.slotflags, 0)
  end
  if isdefined(Base, :__has_internal_change) && Base.__has_internal_change(v"1.12-alpha", :codeinfonargs)
    ci.nargs = length(arguments(ir)) + 1
    ci.isva = false
  end
  argument!(ir, at = 1)
  update!(ci, ir)
end

# JuliaLang/julia#48611: world age is exposed to generated functions.
function func(m::Module, ir::IR)
  generator = @eval m begin
    function $(gensym())(world::UInt, source, self,
                         $([Symbol(:arg, i) for i = 1:length(arguments(ir))]...))
      return $build_codeinfo($ir)
    end
  end
  @eval m begin
    function $(gensym())($([Symbol(:arg, i) for i = 1:length(arguments(ir))]...))
      $(Expr(:meta, :generated, generator))
      $(Expr(:meta, :generated_only))
    end
  end
end

func(ir::IR) = func(Main, ir)

evalir(m::Module, ir::IR, args...) = invokelatest(func(m, ir), args...)
evalir(ir::IR, args...) = evalir(Main, ir, args...)

# TODO: https://hal.inria.fr/inria-00558509v1/document
function liveness(ir)
  result = Dict(v => Set{Variable}() for v in keys(ir))
  result = merge(result, Dict(b.id => Set{Variable}() for b in blocks(ir)))
  queue = WorkQueue(1:length(blocks(ir)))
  while !isempty(queue)
    b = block(ir, pop!(queue))
    for br in branches(b)
      foreach(x -> x isa Variable && push!(result[b.id], x), arguments(br))
      br.condition isa Variable && push!(result[b.id], br.condition)
    end
    live = Set(result[b.id])
    for v in reverse(keys(b))
      delete!(live, v)
      varmap(x -> push!(live, x), b[v])
      union!(result[v], live)
    end
    setdiff!(live, arguments(b))
    for a in predecessors(b)
      isempty(setdiff(live, result[a.id])) && continue
      union!(result[a.id], live)
      push!(queue, a.id)
    end
  end
  return result
end

function interference(liveness)
  g = Graph{Variable}()
  for set in liveness
    set = collect(set)
    for i = 1:length(set), j = i+1:length(set)
      connect!(g, set[i], set[j])
    end
  end
  return g
end

interference(ir::IR) = interference(values(liveness(ir)))

function colouring(g::Graph, pre = Dict())
  nodes = sort(collect(keys(g)), by = x -> length(g[x]), rev = true)
  colours = Dict(n => get(pre, n, -1) for n in nodes)
  for n in nodes
    colour = 1
    while any(m -> colours[m] == colour, g[n])
      colour += 1
    end
    colours[n] = colour
  end
  return colours
end

struct CFG
  graph::Vector{Vector{Int}}
end

function CFG(ir::IR)
  graph = Vector{Int}[]
  for b in blocks(ir)
    push!(graph, Int[])
    for c in successors(b)
      push!(graph[end], c.id)
    end
  end
  return CFG(graph)
end

Base.:(==)(a::CFG, b::CFG) = a.graph == b.graph

Base.length(c::CFG) = length(c.graph)
Base.getindex(c::CFG, b::Integer) = c.graph[b]

function Base.transpose(cfg::CFG)
  cfg′ = CFG([Int[] for _ = 1:length(cfg)])
  for i = 1:length(cfg), j in cfg[i]
    push!(cfg′[j], i)
  end
  return cfg′
end

Base.adjoint(cfg::CFG) = transpose(cfg)

function definitions(b::Block)
  defs = [Variable(i) for i = 1:length(b.ir.defs) if b.ir.defs[i][1] == b.id]
end

function usages(b::Block)
  uses = Set{Variable}()
  prewalk(b) do x
    x isa Variable && push!(uses, x)
    return x
  end
  return uses
end

function usecounts(ir::IR)
  counts = Dict{Variable,Int}()
  prewalk(ir) do x
    x isa Variable && (counts[x] = get(counts, x, 0)+1)
    return x
  end
  return counts
end

function dominators(cfg; entry = 1)
  preds = cfg'
  blocks = [1:length(cfg.graph);]
  doms = Dict(b => Set(blocks) for b in blocks)
  while !isempty(blocks)
    b = popfirst!(blocks)
    # We currently special case the first block here,
    # since Julia sometimes creates blocks with no predecessors,
    # which otherwise throw off the analysis.
    ds = isempty(preds[b]) ? Set([b, entry]) :
      push!(intersect([doms[c] for c in preds[b]]...), b)
    if ds != doms[b]
      doms[b] = ds
      for c in cfg[b]
        c in blocks || push!(blocks, c)
      end
    end
  end
  return doms
end

function domtree(cfg::CFG; entry = 1)
  doms = dominators(cfg, entry = entry)
  doms = Dict(b => filter(c -> b != c && b in doms[c], 1:length(cfg)) for b in 1:length(cfg))
  children(b) = filter(c -> !(c in union(map(c -> doms[c], doms[b])...)), doms[b])
  tree(b) = Pair{Int,Any}(b,tree.(children(b)))
  tree(entry)
end

domtree(ir::IR; entry = 1) = domtree(CFG(ir), entry = entry)

function idoms(cfg; entry = 1)
  ds = zeros(Int, length(cfg))
  _idoms((a, bs)) = foreach(((b, cs),) -> (ds[b] = a; _idoms(b=>cs)), bs)
  _idoms(domtree(cfg, entry = entry))
  return ds
end

function domorder(ir, start = 1; full = false)
  tree = domtree(CFG(ir), entry = start)
  flatten((b,cs)) = vcat(b, flatten.(cs)...)
  tree = flatten(tree)
  if full
    for b = 1:length(ir.blocks)
      b in tree || push!(tree, b)
    end
  end
  return tree
end

domorder!(ir::IR, start = 1) = permute!(ir, domorder(ir, start, full = true))

function verify(ir::IR)
  @assert issorted(domorder(ir)) "Blocks are not in domtree order."
  doms = dominators(ir)
  # TODO check definitions within a block
  for (b, ds) in doms
    defs = union(definitions.(ds)...)
    for x in setdiff(usages(b), defs)
      error("Variable $x in block $(b.id) is not defined.")
    end
  end
  return
end

function renumber(ir)
  p = Pipe(ir)
  for (v, st) in p
    ex = st.expr
    if isbits(ex) # Trivial expressions can be inlined
      delete!(p, v)
      substitute!(p, v, substitute(p, ex))
    end
  end
  return finish(p)
end

function merge_returns!(ir)
  bs = [b for b in blocks(ir) if isreturn(b)]
  length(bs) == 1 && bs[1] == blocks(ir)[end] && return ir
  block!(ir)
  ret = argument!(blocks(ir)[end])
  return!(ir, ret)
  for b in bs
    branches(b)[end] = branch(length(ir.blocks), arguments(branches(b)[end])[1])
  end
  return ir
end

function expand!(ir::IR)
  worklist = blocks(ir)
  spats = Dict(b => Dict() for b in blocks(ir))
  while !isempty(worklist)
    b = pop!(worklist)
    b.id == 1 && continue
    defs = definitions(b)
    uses = usages(b)
    for v in setdiff(uses, defs)
      haskey(spats[b], v) && continue
      spats[b][v] = argument!(b, v)
      for c in predecessors(b)
        c in worklist || push!(worklist, c)
      end
    end
    ir.blocks[b.id] = prewalk(x -> get(spats[b], x, x), ir.blocks[b.id])
  end
  return ir
end

function prune!(ir::IR)
  usages = usecounts(ir)
  worklist = blocks(ir)
  queue!(b) = (b in worklist || push!(worklist, b))
  function rename!(env, ir)
    for b in blocks(ir)
      prewalk!(b) do x
        haskey(env, x) || return x
        foreach(queue!, successors(b))
        env[x]
      end
    end
  end
  while !isempty(worklist)
    b = popfirst!(worklist)
    isempty(arguments(b)) && continue
    brs = filter(br -> br.block == b.id, [br for a in blocks(ir) for br in branches(a)])
    isempty(brs) && continue
    # Redundant due to all inputs being the same
    inputs = [setdiff(in, (a,)) for (a, in) in zip(arguments(b), zip(arguments.(brs)...))]
    del = findall(x -> length(x) == 1, inputs)
    rename = Dict(zip(arguments(b)[del], first.(inputs[del])))
    if !isempty(rename)
      deletearg!(b, del)
      rename!(rename, ir)
    end
    # Redundant due to not being used
    unused = findall(x -> get(usages, x, 0) == 0, arguments(b))
    if !isempty(unused)
      for a in predecessors(b)
        for br in branches(a, b), i in unused
          arguments(br)[i] isa Variable &&
            (usages[arguments(br)[i]] -= 1)
        end
        a in worklist || push!(worklist, a)
      end
      deletearg!(b, unused)
    end
  end
  return ir
end

struct CatchBranch
    defs::Dict{Slot,Any}
    v::Variable
end

# Definedness of a slot's reaching value `r`, for translating `Expr(:isdefined, slot)`.
# A possibly-undefined slot becomes a block argument that carries the `Undefined()`
# sentinel at run time when the slot was never assigned, so:
#   * `r === undef`   -- statically never defined (e.g. reached the entry block with
#                        no definition)             -> `false`
#   * `r isa Variable` -- an SSA value or block argument that may be the sentinel
#                        at run time                 -> `!(r isa Undefined)`
#   * otherwise       -- a concrete constant, always defined -> `true`
definedness(r) =
  r === undef ? false :
  r isa Variable ? xcall(:!, xcall(Core, :isa, r, Undefined)) :
  true

function ssa!(ir::IR)
  current = 1
  defs = Dict(b => Dict{Slot,Any}() for b in 1:length(ir.blocks))
  todo = Dict(b => Dict{Int,Vector{Slot}}() for b in 1:length(ir.blocks))
  catch_branches = Dict{Int,Vector{CatchBranch}}()
  handlers = Int[]
  function reaching(b, slot)
    haskey(defs[b.id], slot) && return defs[b.id][slot]
    b.id == 1 && return undef
    x = add_slot_argument!(b, slot)
    return x
  end
  function add_slot_argument!(b, slot)
    x = argument!(b, type = slot.type, insert = false)
    if !haskey(defs[b.id], slot)
      defs[b.id][slot] = x
    end

    for pred in predecessors(b)
      if pred.id < current
        for br in branches(pred, b)
          push!(br.args, reaching(pred, slot))
        end
      else
        push!(get!(Vector{Slot}, todo[pred.id], b.id), slot)
      end
    end

    if haskey(catch_branches, b.id)
      # for each 'catch' branch to this catch block (catch block has `length(predecessors(b)) == 0`),
      # we try to find the dominating definition for slot v.
      # defs[block(ir, cbr.v).id] contains the defs at the end of
      # the block, so we use the cached defs in catch_branches instead.
      for cbr in catch_branches[b.id]
        # Get the definition for a slot from a given catch branch.
        cbr_v = cbr.v
        stmt = ir[cbr_v]
        if haskey(cbr.defs, slot)
          # Slot v was defined at catch branch
          push!(stmt.expr.args, cbr.defs[slot])
        else
          # Find slot v definition from instruction cbr_v
          cbr_b = block(ir, cbr_v)
          if cbr_b.id == 1
            push!(stmt.expr.args, undef)
            continue
          end

          # there is already a def for this slot as an argument to the block
          # but which was added after the catch branch.
          if haskey(defs[cbr_b.id], slot) && defs[cbr_b.id][slot] isa Variable
            bdef = defs[cbr_b.id][slot]
            (def_b, loc) = ir.defs[bdef.id]
            if def_b == cbr_b.id && loc < 0
              push!(stmt.expr.args, bdef)
              continue
            end
          end

          # add an argument to cbr_b for slot
          new_arg = add_slot_argument!(cbr_b, slot)
          push!(stmt.expr.args, new_arg)
        end
      end
    end

    return x
  end
  function catchbranch!(v)
    for handler in handlers
      cbr = CatchBranch(copy(defs[current]), insertafter!(ir, v, Expr(:catch, handler)))
      push!(get!(Vector{CatchBranch}, catch_branches, handler), cbr)
    end
  end
  for b in blocks(ir)
    current = b.id
    rename(ex) = prewalk(ex) do x
      if x isa Slot
        reaching(b, x)
      elseif isexpr(x, :isdefined) && length(x.args) == 1 && x.args[1] isa Slot
        # `isdefined` must not be renamed like an ordinary use: substituting the
        # slot with its reaching value discards the definedness information.
        definedness(reaching(b, x.args[1]))
      elseif isexpr(x, :isdefined) && length(x.args) == 1 && x.args[1] isa Variable
        # An argument slot is already lowered to a variable by the time we get here
        # (see `IR(::Meta)`), so `isdefined` of it arrives pre-substituted; recover
        # the definedness test the same way.
        definedness(x.args[1])
      else
        x
      end
    end
    for (v, st) in b
      ex = st.expr
      if isexpr(ex, :(=)) && ex.args[1] isa Slot
        defs[b.id][ex.args[1]] = rename(ex.args[2])
        catchbranch!(v)
        delete!(ir, v)
      elseif isexpr(ex, :enter)
        push!(handlers, ex.args[1])
        catchbranch!(v)
      elseif isexpr(ex, :leave) && !haskey(catch_branches, current)
        pop!(handlers)
      else
        ir[v] = rename(ex)
      end
    end
    for i = 1:length(BasicBlock(b).branches)
      BasicBlock(b).branches[i] = rename(BasicBlock(b).branches[i])
    end
    for (succ, ss) in todo[b.id], br in branches(b, succ)
      append!(br.args, [reaching(b, v) for v in ss])
    end
  end
  return ir
end

function reachable_blocks(cfg::CFG)
  bs = Int[]
  reaches(b) = b in bs || (push!(bs, b); reaches.(cfg[b]))
  reaches(1)
  return bs
end

function trimblocks!(ir::IR)
  for b in sort(setdiff(1:length(blocks(ir)), reachable_blocks(CFG(ir))), rev = true)
    deleteblock!(ir, b)
  end
  return ir
end

function inlineable!(ir)
  pushfirst!(ir, Expr(:meta, :inline))
  return ir
end

function log!(ir, msg)
  pushfirst!(ir, xcall(Core, :println, msg))
  return ir
end

totype(T::Type) = T
totype(T::Core.Compiler.PartialStruct) = T.typ

function pis!(ir::IR)
  for (v, st) in ir
    ex = st.expr
    ex isa PiNode || continue
    ir[v] = xcall(Core, :typeassert, ex.val, totype(ex.typ))
  end
  return ir
end

# Unique Work Queue

struct WorkQueue{T}
  items::Vector{T}
end

WorkQueue{T}() where T = WorkQueue(T[])

WorkQueue() = WorkQueue{Any}()

WorkQueue(xs) = WorkQueue(collect(xs))

function Base.push!(q::WorkQueue, x)
  i = findfirst(==(x), q.items)
  i === nothing || (deleteat!(q.items, i))
  push!(q.items, x)
  return q
end

Base.pop!(q::WorkQueue) = pop!(q.items)
Base.isempty(q::WorkQueue) = isempty(q.items)

# Simple Graph

struct Graph{T}
  nodes::Dict{T,Int}
  links::Vector{Set{T}}
end

Graph{T}() where T = Graph{T}(Dict(), [])

Base.length(g::Graph) = length(g.links)
Base.keys(g::Graph) = keys(g.nodes)

function Base.getindex(g::Graph, x)
  if !haskey(g.nodes, x)
    push!(g.links, Set())
    g.nodes[x] = length(g)
  end
  return g.links[g.nodes[x]]
end

function connect!(g::Graph, a, b)
  push!(g[a], b)
  push!(g[b], a)
  return g
end

function fixup_blocks!(ir, n)
  last = length(blocks(ir))
  for bl in blocks(ir), i = 1:length(branches(bl))
    br = branches(bl)[i]
    if br.block > last
      branches(bl)[i] = Branch(br, block = br.block + n - 1)
    end
  end
end

function inlinehere!(ir, line, source, args...)
  source = merge_returns!(copy(source)) # TODO preserve type info
  offset = length(blocks(ir.to))-1
  env = Dict()
  retvalue = nothing
  rename(x::Variable) = env[x]
  rename(x::Expr) = Expr(x.head, rename.(x.args)...)
  rename(x::Statement) = stmt(x; expr=rename(x.expr), line=line)
  rename(x) = x
  for (name, arg) in zip(arguments(source), args)
    env[name] = arg
  end
  for bl in blocks(source)
    if bl.id != 1
      block!(ir)
      for (arg, T) in zip(arguments(bl), argtypes(bl))
        env[arg] = blockargument!(ir, T)
      end
    end
    for (v, st) in bl
      env[v] = push!(ir, rename(st))
    end
    for br in branches(bl)
      if isreturn(br)
        retvalue = rename(returnvalue(br))
      else
        branch!(ir, br.block+offset, rename.(br.args)..., unless = rename(br.condition))
      end
    end
  end
  return retvalue
end

"""
    inline(ir, location, source)

Replace the function call at `ir[location]` with the IR `source`. The inlined IR
will use the function arguments at `ir[location]` as its input.

```
julia> foo(x, y) = max(x, y)+1

julia> ir = @code_ir foo(1, 1)
1: (%1, %2, %3)
  %4 = Main.max(%2, %3)
  %5 = %4 + 1
  return %5

julia> inline(ir, var(4), @code_ir(max(1,1)))
1: (%1, %2, %3)
  %4 = %3 < %2
  %5 = Base.ifelse(%4, %2, %3)
  %6 = %5 + 1
  return %6
```
"""
function inline(ir::IR, loc::Variable, source::IR)
  pr = Pipe(ir)
  startblock = 0
  branches(pr) do br
    if startblock != 0 && br.block > startblock
      Branch(br, block = br.block + length(blocks(source)) - 1)
    else
      return br
    end
  end
  for (v, st) in pr
    if v === loc
      startblock = length(blocks(pr.to))
      fixup_blocks!(pr.to, length(blocks(source)))
      # TODO: when inlining, we set all statements from source
      # ....  at the line from loc. Ideally, we use the `inlined_at` field.
      line = ir[loc].line
      ex = ir[loc].expr
      delete!(pr, v)
      v′ = inlinehere!(pr, line, source, ex.args...)
      substitute!(pr, v, substitute(pr, v′))
    end
  end
  return finish(pr)
end

# A simple dynamo that logs all function calls being made by Julia.

using IRTools: @dynamo, IR, xcall, arguments, insertafter!, recurse!

function hook(f, args...)
  print("Called ", f, "(")
  join(stdout, args, ", ")
  println(")")
end

@dynamo function logcalls(m...)
  ir = IR(m...)
  ir == nothing && return
  recurse!(ir)
  pushfirst!(ir, xcall(Main, :hook, arguments(ir)...))
  return ir
end

# @code_ir logcalls 2+3.0
logcalls(+, 2, 3.0)

module Wrap

using MacroTools: isexpr, prewalk

using ..Inner, ..IRTools
import ..Inner: IR, Variable, Statement, Branch, BasicBlock, Meta, block!,
  unreachable, varmap, argument!, branch!, return!, LineInfoNode
import Core: CodeInfo, GotoNode, SSAValue
import Core.Compiler: IRCode, CFG, GotoIfNot, ReturnNode, StmtRange

import Core.Compiler: InstructionStream

const LineType = Int32

@static if VERSION ≥ v"1.12.0-DEV.173"
  addline!(lines, li) = push!(lines, li, Int32(0), Int32(0))
else
  addline!(lines, li) = push!(lines, li)
end

unvars(ex) = prewalk(x -> x isa Variable ? SSAValue(x.id) : x, ex)

function IRCode(ir::IR)
  defs = Dict()
  stmts, types, lines = [], [], Int32[]
  index = Int[]
  for b in IRTools.blocks(ir)
    if b.id == 1
      for (i, arg) in enumerate(IRTools.arguments(b))
        defs[arg] = Core.SlotNumber(i)
      end
    else
      @assert isempty(BasicBlock(b).args)
    end
    for (v, st) in b
      defs[v] = Variable(length(stmts)+1)
      ex = varmap(x -> get(defs, x, x), st.expr) |> unvars
      @static if isdefined(Core.IR, :EnterNode)
        ex = isexpr(ex, :enter) ? Core.EnterNode(ex.args...) : ex
      end
      push!(stmts, ex)
      push!(types, st.type)
      addline!(lines, st.line)
    end
    for br in BasicBlock(b).branches
      if IRTools.isreturn(br)
        x = get(defs, br.args[1], br.args[1]) |> unvars
        push!(stmts, ReturnNode(x))
      elseif br == unreachable
        push!(stmts, ReturnNode())
      elseif br.condition === nothing
        push!(stmts, GotoNode(br.block))
      else
        cond = get(defs, br.condition, br.condition) |> unvars
        push!(stmts, GotoIfNot(cond, br.block))
      end
      push!(types, Any); addline!(lines, Int32(0))
    end
    push!(index, length(stmts)+1)
  end
  ranges = StmtRange.([1, index[1:end-1]...], index.-1)
  succs = map.(x -> x.id, IRTools.successors.(IRTools.blocks(ir)))
  preds = map.(x -> x.id, IRTools.predecessors.(IRTools.blocks(ir)))
  bs = Core.Compiler.BasicBlock.(ranges, preds, succs)
  cfg = CFG(bs, index)

  flags = UInt32[0x00 for _ in stmts]
  sps = Core.Compiler.VarState[]

  stmtinfo = Core.Compiler.CallInfo[Core.Compiler.NoCallInfo() for _ in 1:length(stmts)]
  stmts = InstructionStream(stmts, types, stmtinfo, lines, flags)
  meta = Expr[]
  @static if VERSION ≥ v"1.12.0-DEV.173"
    nlocs = length(types)
    codelocs = fill(Int32(0), 3nlocs)

    if !isempty(ir.lines)
      LI = first(ir.lines)
      topfile, topline = LI.file, LI.line

      for i in 1:nlocs
        lineidx = lines[3i - 2]
        if lineidx == 0
          continue
        end
        # TODO: support inlining, see passes/inline.jl
        @assert LI.file === topfile && LI.inlined_at == 0
        LI = ir.lines[lineidx]
        codelocs[3i - 2] = LI.line
      end
    else
      topline = Int32(1)
    end
    codelocs = @ccall jl_compress_codelocs(topline::Int32, codelocs::Any, nlocs::Csize_t)::Any

    debuginfo = Core.Compiler.DebugInfoStream(lines)
    debuginfo.def = ir.meta isa Meta ? ir.meta.instance : :var"n/a"
    debuginfo.linetable = Core.DebugInfo(debuginfo.def, nothing, Core.svec(), codelocs)
    IRCode(stmts, cfg, debuginfo, ir.blocks[1].argtypes, meta, sps)
  else
    mod, meth = ir.meta isa Meta ? (ir.meta.method.module, ir.meta.method) : (Main, nothing)
    linetable = map(li -> Core.LineInfoNode(mod, meth, li.file, LineType(li.line), LineType(li.inlined_at)),
                    ir.lines)
    IRCode(stmts, cfg, linetable, ir.blocks[1].argtypes, meta, sps)
  end
end

isgotoifnot(@nospecialize(ex)) = (@assert !isexpr(ex, :gotoifnot); ex isa Core.GotoIfNot)
destruct_gotoifnot(@nospecialize(ex)) = Any[ex.cond, ex.dest]

isreturn(@nospecialize(ex)) = (@assert !isexpr(ex, :return); ex isa ReturnNode)
retval(@nospecialize(ex)) = ex.val

function blockstarts(ci::CodeInfo)
  bs = Int[]
  terminator = false
  for i = 1:length(ci.code)
    ex = ci.code[i]
    if isgotoifnot(ex)
      _, dest = destruct_gotoifnot(ex)
      push!(bs, dest)
      terminator = true
    elseif ex isa GotoNode || isreturn(ex)
      ex isa GotoNode && push!(bs, ex.label)
      i < length(ci.code) && push!(bs, i+1)
      terminator = false
    elseif terminator
      push!(bs, i)
      terminator = false
    end
  end
  return sort(unique(bs))
end

# TODO more informative names, while avoiding clashes.
slotname(ci, s) = Symbol(:_, s.id)

function IR(ci::CodeInfo, nargs::Integer; meta = nothing)
  bs = blockstarts(ci)
  codelocs, linetable = @static if VERSION ≥ v"1.12.0-DEV.173"
    def = isnothing(meta) ? :var"n/a" : meta.instance
    N = length(ci.code)
    codelocs = fill(0, N)
    linetable = LineInfoNode[]

    # NOTE: we could be faster about decoding here and support inlining?
    for pc in 1:N
      LI = Base.IRShow.buildLineInfoNode(ci.debuginfo, def, pc)
      if !isempty(LI)
        linode = first(LI) # ::Base.IRShow.LineInfoNode
        push!(linetable, LineInfoNode(linode.file, linode.line))
        codelocs[pc] = length(linetable)
      end
    end

    codelocs, linetable
  else
    ci.codelocs, map(li -> LineInfoNode(li.file, li.line), ci.linetable)
  end
  ir = IR(linetable, meta = meta)
  _rename = Dict()
  rename(ex) = prewalk(ex) do x
    haskey(_rename, x) && return _rename[x]
    x isa Core.SlotNumber && return Inner.Slot(slotname(ci, x))
    return x
  end
  for i = 1:nargs
    arg = argument!(ir)
    _rename[Core.SlotNumber(i)] = arg
    # As of Julia 1.14, lowered code (e.g. the `:new` in a struct constructor)
    # can reference arguments as `Core.Argument` rather than `Core.SlotNumber`.
    _rename[Core.Argument(i)] = arg
  end
  for i = 1:length(ci.code)
    i in bs && block!(ir)
    ex = ci.code[i]
    if ex isa Core.NewvarNode
      continue
    elseif @static if isdefined(Core.IR, :EnterNode); ex isa Core.IR.EnterNode else isexpr(ex, :enter) end
      catch_dest = @static if isdefined(Core.IR, :EnterNode)
          ex.catch_dest
      else
          ex.args[1]
      end
    enter_expr = Expr(:enter, findfirst(==(catch_dest), bs)+1)
      isdefined(ex, :scope) && push!(enter_expr.args, ex.scope)
      _rename[Core.SSAValue(i)] = push!(ir, enter_expr)
    elseif ex isa GotoNode
      branch!(ir, findfirst(==(ex.label), bs)+1)
    elseif isgotoifnot(ex)
      cond, dest = destruct_gotoifnot(ex)
      branch!(ir, findfirst(==(dest), bs)+1,
              unless = rename(cond))
    elseif isreturn(ex)
      return!(ir, rename(retval(ex)))
    elseif ex isa GlobalRef && VERSION >= v"1.12.0-DEV.173"
      # As of Julia 1.12, lowering hoists the callee of a call into its own
      # statement (e.g. `%4 = Main.:*; %5 = (%4)(%2, %3)`). Inline such bare
      # `GlobalRef` statements back into their use sites so the IR retains the
      # shape it had on earlier versions (`%4 = %2 * %3`).
      #
      # This must stay gated to versions that actually hoist: on <1.12, lowering
      # never emits a bare `GlobalRef` statement, but downstream IR producers
      # (e.g. Zygote's forward-mode dynamo) can, and inlining those reshapes the
      # IR in a way that breaks them (Zygote's nested `pushforward` recursed
      # without terminating on Julia 1.10).
      _rename[Core.SSAValue(i)] = ex
    else
      _rename[Core.SSAValue(i)] = push!(ir, IRTools.stmt(rename(ex), line = codelocs[i]))
    end
  end
  return ir
end

function IR(meta::Meta; slots = false, prune = true)
  ir = IR(meta.code, meta.nargs, meta = meta)
  slots && return ir
  ir = IRTools.ssa!(ir)
  if prune
    ir = ir |> IRTools.prune! |> IRTools.renumber
  end
  return ir
end

function IR(Ts::Type...; slots = false, prune = true)
  m = IRTools.meta(Tuple{Ts...})
  m == nothing && return
  IR(m, slots = slots, prune = prune)
end

end

# Find strongly connected components
function strongconnected(cfg; blocks = 1:length(cfg))
  preorder = zeros(Int, length(cfg))
  S, P = Int[], Int[]
  C = Ref(0)
  components = Vector{Int}[]
  let # avoid boxing `search`
    function search(v)
      preorder[v] = (C[] += 1)
      push!(S, v)
      push!(P, v)
      for w in cfg[v]
        w in blocks || continue
        if preorder[w] == 0
          search(w)
        elseif !any(c -> w in c, components)
          while preorder[P[end]] > preorder[w] pop!(P) end
        end
      end
      if P[end] == v
        pop!(P)
        pushfirst!(components, Int[])
        while true
          push!(components[1], pop!(S))
          components[1][end] == v && break
        end
      end
    end
    for b in blocks
      preorder[b] == 0 && search(b)
    end
  end
  return components
end

struct Component
  children::Vector{Union{Component,Int}}
end

blocks(c::Integer) = [c]
blocks(c::Component) = reduce(vcat, blocks.(c.children))

entries(c::Integer) = [c]
entries(c::Component) = entries(first(c.children))

function components(cfg::CFG; blocks = 1:length(cfg))
  # Assume the first block is the entry.
  cs = strongconnected(cfg, blocks = blocks[2:end])
  Component([blocks[1],
             [length(c) == 1 ? c[1] : components(cfg, blocks = sort(c)) for c in cs]...])
end

# Aaaargh
_union(xs...) = union(xs...)
_union() = []

function branchesto(cfg::CFG, cs, i)
  c = cs.children[i]
  valid = _union([entries(cs.children[j]) for j = 1:length(cs.children) if i != j]...)
  preds = _union([cfg'[c] for c in blocks(c)]...)
  forw = filter(next -> next < entries(c)[1] && next in valid, preds)
  back = filter(next -> next > entries(c)[1] && next in valid, preds)
  forw = isempty(forw) ? nothing : minimum(forw)
  back = isempty(back) ? nothing : maximum(back)
  forw, back
end

function stackify(cfg::CFG, cs::Component = components(cfg), forw = [], back = [])
  entry = cs.children[1]
  for (i, c) = enumerate(cs.children)
    target = minimum(entries(c))
    f, b = branchesto(cfg, cs, i)
    f == nothing || push!(forw, entry=>target)
    b == nothing || push!(back, b    =>target)
    c isa Component && stackify(cfg, c, forw, back)
  end
  return forw, back
end

struct Slot
  id::Symbol
  type
end

Slot(id) = Slot(id, Any)

function Base.show(io::IO, s::Slot)
  print(io, "@", s.id)
  s.type != Any && print(io, "::", s.type)
end

phislot(b, i) = Slot(Symbol(:phi_, b, :_, i))

sloteq(a, b) = a isa Slot && b isa Slot && a.id === b.id

# Lower a parallel copy `dests .= srcs` (block-argument passing) into a sequence
# of scalar assignments appended to block `b`. Naively emitting `dest_i = src_i`
# in order is wrong when a destination slot is also used as a source (e.g. the
# swap `a, b = b, a` produced by a loop), because an earlier assignment clobbers
# a value a later one still needs. We therefore emit moves in a safe order,
# breaking cycles by spilling a destination to a fresh temporary first.
function copyargs!(b, dests, srcs)
  srcs = collect(Any, srcs)
  todo = [i for i = 1:length(dests) if !sloteq(dests[i], srcs[i])]
  while !isempty(todo)
    k = findfirst(i -> !any(j -> sloteq(srcs[j], dests[i]), todo), todo)
    if k === nothing
      # Only cycles remain; break one by saving a destination to a temporary.
      i = first(todo)
      tmp = Slot(gensym(:copy))
      push!(b, :($tmp = $(dests[i])))
      for j in todo
        sloteq(srcs[j], dests[i]) && (srcs[j] = tmp)
      end
    else
      i = todo[k]
      push!(b, :($(dests[i]) = $(srcs[i])))
      deleteat!(todo, k)
    end
  end
  return b
end

# TODO: handle undef arguments properly.
function slots!(ir::IR)
  slots = Dict()
  for b in blocks(ir)
    # Block arguments
    if b.id != 1
      for (i, var) in enumerate(BasicBlock(b).args)
        slots[var] = phislot(b.id, i)
      end
      empty!(BasicBlock(b).args)
      empty!(BasicBlock(b).argtypes)
    end
    # Catch branches
    for (v, st) in b
      isexpr(st.expr, :catch) || continue
      target = st.expr.args[1]
      args   = st.expr.args[2:end]
      for (i, val) in enumerate(args)
        insert!(b, v, :($(phislot(target, i)) = $val))
      end
      delete!(b, v)
    end
    # Branches
    for br in BasicBlock(b).branches
      isreturn(br) && continue
      dests = [phislot(br.block, i) for i = 1:length(br.args)]
      # Resolve sources to the slots they will become, so that cycles introduced
      # by block-argument permutations (e.g. swaps) can be detected and broken.
      srcs = [get(slots, a, a) for a in br.args]
      copyargs!(b, dests, srcs)
      empty!(br.args)
    end
  end
  return varmap(x -> get(slots, x, x), ir)
end

using Core.Compiler: CodeInfo, SlotNumber

function slots!(ci::CodeInfo)
  ss = Dict{Slot,SlotNumber}()
  for i = 1:length(ci.code)
    function f(x)
      x isa Slot || return x
      haskey(ss, x) && return ss[x]
      push!(ci.slottypes, x.type)
      push!(ci.slotnames, x.id)
      push!(ci.slotflags, 0x00)
      ss[x] = SlotNumber(length(ci.slotnames))
    end
    ci.code[i] = MacroTools.prewalk(ci.code[i]) do x
      x isa Core.ReturnNode ? (isdefined(x,:val) ? Core.ReturnNode(f(x.val)) : x) :
      x isa Core.GotoIfNot ? Core.GotoIfNot(f(x.cond), x.dest) :
      f(x)
    end
  end
  return ci
end

function varargs!(meta, ir::IR, n = 0)
  isva = meta.method.isva
  argTs = ir.blocks[1].argtypes
  Ts = Core.Compiler.widenconst.(argTs[n+1:end])
  typed = !all(T -> T==Any, Ts)
  allTs = !isva ?
    Any[argTs[1:n]..., Tuple{Ts...}] :
    Any[argTs[1:n]..., typed ? Tuple{Ts[1:end-1]...,Ts[end].parameters...} : Any]
  args = copy(ir.blocks[1].args)
  deletearg!(ir, length(allTs)+1:length(args))
  empty!(argTs); append!(argTs, allTs)
  argmap = Dict{Variable,Any}()
  argis = 1:(length(Ts))
  newargs = map(reverse(argis)) do i
    argmap[args[i+n]] = pushfirst!(ir, Statement(nothing, type = Ts[i]))
  end |> reverse
  ir = varmap(x -> get(argmap, x, x), ir)
  for i in argis
    if isva && i == length(argis)
      i = length(Ts)
      xs, T = arguments(ir)[end], argTs[end]
      for _ = 1:i-1
        T = typed ? Tuple{T.parameters[2:end]...} : Any
        st = Statement(xcall(Base, :tail, xs), type = T)
        xs = insertafter!(ir, xs, st)
      end
      ir[newargs[i]] = xcall(:identity, xs)
    else
      ir[newargs[i]] = xcall(Base, :getfield, arguments(ir)[end], i)
    end
  end
  return ir
end

function closureargs!(ir::IR)
  args = arguments(ir)[2:end]
  deletearg!(ir, 2:length(arguments(ir)))
  argtuple = argument!(ir)
  env = Dict()
  for (i, a) in reverse(collect(enumerate(args)))
    env[a] = pushfirst!(ir, xcall(:getindex, argtuple, i))
  end
  prewalk!(x -> get(env, x, x), ir)
  return ir
end

# TODO this is hacky and leaves `ir.defs` incorrect
function splicearg!(ir::IR)
  args = arguments(ir)
  push!(ir.defs, (1, -1))
  arg = var(length(ir.defs))
  pushfirst!(args, arg)
  pushfirst!(ir.blocks[1].argtypes, Any)
  return arg
end

function replace_code_newstyle!(ci, ir, _)
  isnothing(ci.slottypes) && (ci.slottypes = Any[])
  return Core.Compiler.replace_code_newstyle!(ci, ir)
end

function get_staged(mi, world)
  return Core.Compiler.get_staged(mi, world)
end

function update!(ci::CodeInfo, ir::Core.Compiler.IRCode)
  replace_code_newstyle!(ci, ir, length(ir.argtypes))
  @static if VERSION < v"1.12.0-DEV.15"
    ci.inferred = false
  end
  ci.ssavaluetypes = length(ci.code)
  slots!(ci)
  fill!(ci.slotflags, 0)
  return ci
end

function update!(ci::CodeInfo, ir::IR)
  if ir.meta isa Meta
    ci.method_for_inference_limit_heuristics = ir.meta.method
    if isdefined(ci, :edges)
      # `CodeInfo.edges` uses a heterogeneous, interleaved backedge format, so the
      # canonical container is a `Vector{Any}`. Julia 1.14 asserts this element type
      # in `compute_edges!`, rejecting a concrete `Vector{Core.MethodInstance}`.
      ci.edges = Any[ir.meta.instance]
    end
  end
  update!(ci, Core.Compiler.IRCode(slots!(ir)))
end

# An implementation of delimited continuations (the shift/reset operators) in
# Julia. Works by transforming all Julia code to continuation passing style.
# The `shift` operator then just has to return the continuation.

# https://en.wikipedia.org/wiki/Delimited_continuation
# https://en.wikipedia.org/wiki/Continuation-passing_style

using IRTools.All

struct Func
  f # Avoid over-specialising on the continuation object.
end

(f::Func)(args...) = f.f(args...)

function captures(ir, vs)
  us = Set()
  for v in vs
    isexpr(ir[v].expr) || continue
    foreach(x -> x isa Variable && push!(us, x), ir[v].expr.args)
  end
  return setdiff(us, vs)
end

rename(env, x) = x
rename(env, x::Variable) = env[x]
rename(env, x::Expr) = Expr(x.head, rename.((env,), x.args)...)
rename(env, x::Statement) = stmt(x, expr = rename(env, x.expr))

excluded = [GlobalRef(Base, :getindex)]

function continuation!(bl, ir, env, vs, ret)
  rename(x) = Main.rename(env, x)
  local v, st
  while true
    isempty(vs) && return return!(bl, rename(Expr(:call, ret, returnvalue(block(ir, 1)))))
    v = popfirst!(vs)
    st = ir[v]
    isexpr(st.expr, :call) && !(st.expr.args[1] ∈ excluded) && break
    isexpr(st.expr, :lambda) &&
      (st = stmt(st, expr = Expr(:lambda, cpslambda(st.expr.args[1]), st.expr.args[2:end]...)))
    env[v] = push!(bl, rename(st))
  end
  cs = [ret, setdiff(captures(ir, vs), [v])...]
  if isempty(vs)
    next = rename(ret)
  else
    next = push!(bl, Expr(:lambda, continuation(ir, vs, cs, v, ret), rename.(cs)...))
    next = xcall(Main, :Func, next)
  end
  ret = push!(bl, stmt(st, expr = xcall(Main, :cps, next, rename(st.expr).args...)))
  return!(bl, ret)
end

function continuation(ir, vs, cs, in, ret)
  bl = empty(ir)
  env = Dict()
  self = argument!(bl)
  env[in] = argument!(bl)
  for (i, c) in enumerate(cs)
    env[c] = pushfirst!(bl, xcall(:getindex, self, i))
  end
  continuation!(bl, ir, env, vs, ret)
end

cpslambda(ir) = cpstransform(ir, true)

function cpstransform(ir, lambda = false)
  lambda || (ir = functional(ir))
  k = argument!(ir, at = lambda ? 2 : 1)
  bl = empty(ir)
  env = Dict()
  for arg in arguments(ir)
    env[arg] = argument!(bl)
  end
  continuation!(bl, ir, env, keys(ir), k)
end

cps(k, f::Core.IntrinsicFunction, args...) = k(f(args...))
cps(k, f::IRTools.Lambda{<:Tuple{typeof(cps),Vararg{Any}}}, args...) = f(k, args...)
cps(k, ::typeof(cond), c, t, f) = c ? cps(k, t) : cps(k, f)
cps(k, ::typeof(cps), args...) = k(cps(args...))

# Speed up compilation
for f in [Broadcast.broadcasted, Broadcast.materialize]
  @eval cps(k, ::typeof($f), args...) = k($f(args...))
end

@dynamo function cps(k, args...)
  ir = IR(args...)
  ir == nothing && return :(args[1](args[2](args[3:end]...)))
  cpstransform(IR(args...))
end

# shift/reset

reset(f) = cps(identity, f)
shift(f) = error("`shift` must be called inside `reset`")
cps(k, ::typeof(shift), f) = f(k)

macro reset(ex)
  :(reset(() -> $(esc(ex))))
end

k = @reset begin
  shift(k -> k)^2
end

k(4) == 16

using IRTools, Test
using IRTools: @meta, IR, CFG, Simple, Loop, Multiple, reloop, explicitbranch!, stackify

relu(x) = (y = x > 0 ? x : 0)

relu_cfg = CFG(@code_ir relu(1))

@test relu_cfg == CFG([[3,2],[4],[4],[]])

@test reloop(relu_cfg) == Simple(1, Multiple([Simple(3), Simple(2)], Simple(4)))

@test sort.(stackify(relu_cfg)) == ([1=>2,1=>3,1=>4],[])

function pow(x, n)
  r = 1
  while n > 0
    n -= 1
    r *= x
  end
  return r
end

pow_cfg = CFG(@code_ir pow(2, 3))

@test pow_cfg == CFG([[2],[4,3],[2],[]])

@test reloop(pow_cfg) == Simple(1, Loop(Simple(2, Simple(3)), Simple(4)))

@test sort.(stackify(pow_cfg)) == ([1=>2,1=>4,2=>3],[3=>2])

# AST recovery

relu(x) = (y = x > 0 ? x : 0)

ir = explicitbranch!(IR(@meta(relu(1)), slots = true))
ex = reloop(ir)

@test eval(:(let arg2 = 5; $ex; end)) == 5
@test eval(:(let arg2 = -5; $ex; end)) == 0

relu(x) = x > 0 ? x : 0

ir = explicitbranch!(IR(@meta(relu(1)), slots = true))
ex = reloop(ir)

@test eval(:(let arg2 = 5; $ex; end)) == 5
@test eval(:(let arg2 = -5; $ex; end)) == 0

ir = explicitbranch!(IR(@meta(pow(1,1)), slots = true))
ex = reloop(ir)

@test eval(:(let arg2 = 5, arg3 = 3; $ex; end)) == 125

ir = explicitbranch!(IR(@meta(gcd(1,1)), slots = true))
ex = reloop(ir)

@test eval(:(let arg2 = 85, arg3 = 391; $ex; end)) == gcd(85, 391)

using IRTools: @dynamo, argument!, IR

# Implementation of `invoke(f, argtypes::Type, args...`, where `args` don't have
# to conform to `argtypes`.  i.e., it allows you to call `f` on `args`, but using the
# method for `argtypes`.
# See https://julialang.slack.com/archives/CJ357CY2Y/p1579598240011500.

@dynamo function sneakyinvoke(f, ::Type{T}, args...) where T<:Tuple
  ir = IR(f, T.parameters...)
  argument!(ir, at = 2)
  return ir
end

f(x::Float64) = x^2

sneakyinvoke(f, Tuple{Float64}, 2)

using IRTools, MacroTools, InteractiveUtils, Test
using IRTools: @dynamo, IR, meta, isexpr, xcall, self, insertafter!, recurse!,
  argument!, return!, block!, branch!, func, var, functional
using InteractiveUtils: code_typed

@dynamo roundtrip(a...) = IR(a...)

@dynamo function passthrough(a...)
  ir = IR(a...)
  ir == nothing && return
  recurse!(ir)
  return ir
end

add(a, b) = a+b
@test roundtrip(add, 2, 3) == 5
@test passthrough(add, 2, 3) == 5
@test passthrough(sin, 1.0) == sin(1.0)

f_returnnode(::T) where {T} = T
@test passthrough(f_returnnode, 1) == Int
f_gotoifnot(::Val{x}) where {x} = x ? 1 : 0
@test passthrough(f_gotoifnot, Val(true)) == 1

@test @code_ir(passthrough, add(2, 3)) isa IR

IRTools.refresh(roundtrip)

add(a, b) = a*b
@test roundtrip(add, 2, 3) == 6

relu(x) = x > 0 ? x : 0
@test roundtrip(relu, 1) == 1
@test passthrough(relu, 1) == 1

foo(x) = y = x > 0 ? x + 1 : x - 1
@test roundtrip(foo, 1) == 2
@test roundtrip(foo, -1) == -2
@test passthrough(foo, 1) == 2

@test passthrough(() -> [1, 2, 3]) == [1, 2, 3]

# Loop-carried variables that permute on a back-edge lower to a parallel copy of
# block arguments; sequentialising it naively drops values (FluxML/Zygote.jl#1198).
function swap_loop(x, y, n)
  for _ in 1:n
    x, y = y, x
  end
  return x
end
for n in 0:5
  @test roundtrip(swap_loop, 10, 20, n) == swap_loop(10, 20, n)
end

function rotate_loop(a, b, c, n)
  for _ in 1:n
    a, b, c = b, c, a
  end
  return (a, b, c)
end
for n in 0:6
  @test roundtrip(rotate_loop, 1, 2, 3, n) == rotate_loop(1, 2, 3, n)
end

function err(f)
  try
    f()
  catch e
    e
  end
end

@test passthrough(err, () -> 2+2) == 4
@test passthrough(err, () -> 0//0) isa ArgumentError

function err2(f)
    x = 1
    y = 1
    try
        y = f()
    catch e
      x, y
    end
    x, y
end

@test passthrough(err2, () -> 2+2) == (1, 4)
@test passthrough(err2, () -> 0//0) == (1, 1)

function err3(f)
  y = 1
  try
    y = f()
  catch
  end
  return y
end

@test passthrough(err3, () -> 2+2) == 4
@test passthrough(err3, () -> 0//0) == 1

@dynamo function mullify(a...)
  ir = IR(a...)
  ir == nothing && return
  ir = MacroTools.prewalk(ir) do x
    x isa GlobalRef && x.name == :(*) && return GlobalRef(Base, :+)
    return x
  end
  for (x, st) in ir
    isexpr(st.expr, :call) || continue
    ir[x] = xcall(Main, :mullify, st.expr.args...)
  end
  return ir
end

@test mullify(prod, [5, 10]) == 15

@dynamo err(a...) = 0//0

@test_throws IRTools.Inner.CompileError err(+, 2, 3)

mutable struct Context
  calls::Int
end

@dynamo function (cx::Context)(a...)
  ir = IR(a...)
  ir == nothing && return
  recurse!(ir)
  calls = pushfirst!(ir, xcall(:getfield, self, QuoteNode(:calls)))
  calls = insertafter!(ir, calls, xcall(:+, calls, 1))
  insertafter!(ir, calls, xcall(:setfield!, self, QuoteNode(:calls), calls))
  return ir
end

@code_lowered Context(0)(add, 2, 3)

cx = Context(0)
@test cx(add, 2, 3.0) == 6
@test cx.calls > 5

ir = IR()
x = argument!(ir)
y = push!(ir, xcall(:*, x, x))
return!(ir, y)

@test IRTools.evalir(ir, 5) == 25

ir = IR()
x = argument!(ir)
y = argument!(ir)
z = push!(ir, xcall(:*, x, y))
return!(ir, z)

@test IRTools.evalir(ir, 5, 3) == 15

function pow(x, n)
  r = 1
  while n > 0
    n -= 1
    r *= x
  end
  return r
end

ir = @code_ir pow(2, 3)

ir[var(8)] = xcall(:+, var(5), var(2))

mul = func(ir)

@test mul(nothing, 10, 3) == 31

@dynamo function ir_add(_, _)
  ir = IR()
  args = argument!(ir)
  x = push!(ir, xcall(:getindex, args, 1))
  y = push!(ir, xcall(:getindex, args, 2))
  return!(ir, xcall(:+, x, y))
end

@test ir_add(5, 2) == 7

@dynamo function test_lambda(x)
  λ = IR()
  self = argument!(λ)
  y = argument!(λ)
  x = push!(λ, xcall(:getindex, self, 1))
  return!(λ, xcall(:+, x, y))
  ir = IR()
  args = argument!(ir)
  x = push!(ir, xcall(:getindex, args, 1))
  return!(ir, Expr(:lambda, λ, x))
end

let
  f = test_lambda(3)
  @test f(6) == 9
end

anf(f::Core.IntrinsicFunction, args...) = f(args...)

@dynamo function anf(args...)
  ir = IR(args...)
  ir == nothing && return
  functional(recurse!(ir))
end

@test anf(pow, 2, 3) == 8

function f94(x)
    i = x
    while i > 0
        i -= 1
    end
    return x
end
@test f94(1) == 1
@test passthrough(f94, 1) == 1

@testset "unreachable" begin
    # 1: (%1)
    #   return nothing
    # 2:
    #   unreachable
    ir = IR()
    argument!(ir)
    return!(ir, nothing)
    block!(ir)
    branch!(ir, 0)

    func_ir = IRTools.func(ir)
    @test (code_typed(func_ir, Tuple{typeof(func_ir)}) |> only
           isa Pair{Core.CodeInfo,DataType})
end

function f_try_catch(x)
    y = 0.
    try
        y = sqrt(x)
    catch

    end
    y
end

function f_try_catch2(x, cond)
    local y
    if cond
        y = 2x
    end

    try
        x = 3 * error()
    catch
    end

    y
end

function f_try_catch3()
    local x
    try
        error()
    catch
        x = 42
    end
    x
end

function f_try_catch4(x, cond)
    local y
    try
        throw(x)
    catch err
        if cond
            y = err + x
        end
    end
    y
end

function f_try_catch5(x, cond)
    local y
    cond && (x = 2x)
    try
        y = x
        cond && error()
    catch
        y = x + 1
    end
    y
end

function f_try_catch6(cond, y)
    x = 1

    if cond
        y = 10y
    else
        y = 10y
    end

    try
        cond && error()
    catch
        y = 2x
    end

    y+x
end

function f_try_catch7()
  local x = 1.

  for _ in 1:10

      try
          x = sqrt(x)
          x -= 1.
      catch
          x = -x
      end

      x = x ^ 2
  end

  x
end

function f_try_catch8(x)
    local z = x
    try
        z = z + sqrt(x)
        z = 1 - log(z)
        z = log(z)
    catch
        z = abs(z)
    finally
        return z
    end
end

@testset "try/catch" begin
    ir = @code_ir f_try_catch(1.)
    fir = func(ir)
    @test fir(nothing,1.) === 1.
    @test fir(nothing,-1.) === 0.

    ir = @code_ir f_try_catch2(1., false)
    fir = func(ir)

    # This should be @test_throws UndefVarError fir(nothing,42,false)
    # See TODO in `IRTools.slots!`
    @test_broken try
        fir(nothing,42,false)
        false
    catch e
        e isa UndefVarError
    end
    @test fir(nothing, 42, false) === IRTools.undef
    @test fir(nothing, 42, true) === 84

    ir = @code_ir f_try_catch3()
    @test all(ir) do (_, stmt)
        !IRTools.isexpr(stmt.expr, :catch) ||
          length(stmt.expr.args) == 1
    end
    fir = func(ir)
    @test fir(nothing) == 42

    ir = @code_ir f_try_catch4(42, false)
    fir = func(ir)
    # This should be @test_throws UndefVarError fir(nothing,42,false)
    @test_broken try
        fir(nothing, 42, false)
        false
    catch e
        e isa UndefVarError
    end
    @test fir(nothing, 42, false) === IRTools.undef
    @test fir(nothing, 42, true) === 84

    ir = @code_ir f_try_catch5(1, false)
    fir = func(ir)
    @test fir(nothing, 3, false) === 3
    @test fir(nothing, 3, true) === 7

    ir = @code_ir f_try_catch6(true, 1)
    fir = func(ir)
    @test fir(nothing, true, 1) === 3
    @test fir(nothing, false, 1) === 11

    ir = @code_ir f_try_catch7()
    fir = func(ir)
    @test fir(nothing) === 1.

    ir = @code_ir f_try_catch8(1.)
    fir = func(ir)
    @test fir(nothing, 1.) == log(1. - log(2.))
    @test fir(nothing, -1.) == 1.
end

# `@isdefined` on a conditionally-defined local. SSA conversion turns the slot into
# a block argument carrying `Undefined()` when unassigned, so `isdefined` must test
# for that rather than substituting the slot's value (which is always "defined").
function f_isdefined(x)
    local y
    x > 0 && (y = 3x)
    @isdefined(y) ? y : zero(x)
end

# `isdefined` of an argument: the arg slot is lowered to a variable before `ssa!`,
# so this arrives as `isdefined(<variable>)` rather than `isdefined(<slot>)`.
f_isdefined_arg(x) = @isdefined(x) ? x * 2 : zero(x)

@testset "isdefined" begin
    ir = @code_ir f_isdefined(1.)
    # The `isdefined` node must not survive with a value argument in its place.
    @test !any(ir) do (_, stmt)
        IRTools.isexpr(stmt.expr, :isdefined)
    end
    fir = func(ir)
    @test fir(nothing, 2.) === 6.    # y defined
    @test fir(nothing, -1.) === 0.   # y undefined -> else branch
    @test passthrough(f_isdefined, 2.) === 6.
    @test passthrough(f_isdefined, -1.) === 0.

    ir = @code_ir f_isdefined_arg(1.)
    @test !any(ir) do (_, stmt)
        IRTools.isexpr(stmt.expr, :isdefined)
    end
    fir = func(ir)
    @test fir(nothing, 2.) === 4.
    @test passthrough(f_isdefined_arg, 2.) === 4.
end

using Documenter, IRTools

makedocs(
  modules=[IRTools],
  sitename="IRTools",
  pages = [
        "Home" => "index.md",
        "Dynamo" => "dynamo.md",
        "Reference" => "reference.md"],
  # Many docstrings are not yet included in the manual and some cross-references
  # are unresolved; warn instead of erroring so the build still succeeds.
  warnonly = [:missing_docs, :cross_references],
  format = Documenter.HTML(prettyurls = haskey(ENV, "CI")))

deploydocs(
    repo = "github.com/MikeInnes/IRTools.jl.git",
)

# A simple forward-mode AD. Simplified so that many things don't work (e.g.
# control flow), but shows the basic ideas.

using IRTools.All
using IRTools: Pipe
using Base: tail

ntail(x, n) = n <= 0 ? x : xcall(:tail, ntail(x, n-1))

zerolike(x::Number) = zero(x)
zerolike(x::Tuple) = zerolike.(x)
zerolike(x::T) where T =
  NamedTuple{fieldnames(T)}(map(f -> zerolike(getfield(x, f)), fieldnames(T)))
zerolike(x::Union{Module,Type}) = nothing

function instrument!(pr, v, st)
  ex = st.expr
  if isexpr(ex, :new)
    st = stmt(st, expr = xcall(Main, :__new__, ex.args...))
    pr[v] = st
  end
  return st
end

function dual(ir)
  pr = Pipe(ir)
  Δs = Dict()
  partial(x::Variable) = Δs[x]
  partial(v, x::Variable) = Δs[x]
  partial(v, x) = insert!(pr, v, xcall(Main, :zerolike, x))
  dx = argument!(pr, at = 1)
  for (i, x) in enumerate(arguments(ir))
    if i == length(arguments(ir)) && ir.meta.method.isva
      Δs[x] = push!(pr, ntail(dx, i-1))
    else
      Δs[x] = push!(pr, xcall(:getindex, dx, i))
    end
  end
  for (v, st) in pr
    st = instrument!(pr, v, st)
    if isexpr(st.expr, :call)
      dargs = insert!(pr, v, xcall(:tuple, partial.((v,), st.expr.args)...))
      result = insert!(pr, v, stmt(st, expr = xcall(Main, :diff, dargs, st.expr.args...)))
      pr[v] = xcall(:getindex, result, 1)
      Δs[v] = push!(pr, xcall(:getindex, result, 2))
    elseif !isexpr(st.expr)
      Δs[v] = push!(pr, xcall(Main, :zerolike, v))
    else
      error("Unsupported $(st.expr.head) expression")
    end
  end
  ret = returnvalue(block(ir, 1))
  return!(pr, xcall(:tuple, ret, partial(ret)))
  return finish(pr)
end

@dynamo function diff(_, x...)
  ir = IR(x...)
  ir == nothing && return :(error("non-differentiable function $(args[2])"))
  @assert length(blocks(ir)) == 1 "Control flow not yet supported"
  return dual(ir)
end

@generated function __new__(T, args...)
  quote
    Base.@_inline_meta
    $(Expr(:new, :T, [:(args[$i]) for i = 1:length(args)]...))
  end
end

# Julia internal definitions
diff(_, ::typeof(zerolike), x) = zerolike(x), zerolike(x)
diff(_, ::typeof(one), x) = one(x), zerolike(x)
diff(_, ::typeof(println), x...) = println(x...), nothing
diff(_, ::typeof(typeof), x) = typeof(x), nothing
diff(_, ::typeof(Core.apply_type), args...) = Core.apply_type(args...), nothing
diff(ṫ, ::typeof(tuple), t...) = t, tail(ṫ)
diff((_, ṫ, _), ::typeof(getfield), t, i) = getfield(t, i), getfield(ṫ, i)
diff((_, ṫ, _), ::typeof(getindex), t, i) = getindex(t, i), getindex(ṫ, i)
diff(ṡ, ::typeof(__new__), T, s...) = __new__(T, s...), NamedTuple{fieldnames(T)}(tail(tail(ṡ)))

# Mathematical definitions
diff((_, ȧ, ḃ), ::typeof(+), a, b) = a + b, ȧ + ḃ
diff((_, ȧ, ḃ), ::typeof(-), a, b) = a - b, ȧ - ḃ
diff((_, ȧ, ḃ), ::typeof(*), a, b) = a*b, ȧ*b+ḃ*a
diff((_, ȧ), ::typeof(-), a) = -a, -ȧ

diff((_, ẋ), ::typeof(sin), x) = sin(x), ẋ*cos(x)
diff((_, ẋ), ::typeof(cos), x) = cos(x), -ẋ*sin(x)

# Test cases

D(f, x) = diff((zerolike(f), one(x)), f, x)[2]

D(x -> sin(cos(x)), 0.5) # -cos(cos(x))sin(x)

D(x -> D(cos, x), 0.5) # -cos(x)

D(x -> x*D(y -> x*y, 1), 4) # 8

using Core: CodeInfo, Typeof
using Core.Compiler: InferenceState, MethodInstance, svec
using Base: typesof

hasgenerator(x) = Base.hasgenerator(x)

worldcounter() = ccall(:jl_get_world_counter, UInt, ())

isprecompiling() = ccall(:jl_generating_output, Cint, ()) == 1

struct Meta
  method::Method
  instance::MethodInstance
  code::CodeInfo
  nargs::Int
  sparams
end

function Base.show(io::IO, meta::Meta)
  print(io, "Metadata for ")
  print(io, meta.method)
end

# Workaround for what appears to be a Base bug
untvar(t::TypeVar) = t.ub
untvar(x) = x

const spoofed_world = Ref{Union{Nothing,UInt}}(nothing)

"""
    meta(Tuple{...})

Construct metadata for a given method signature. Metadata can then be used to
construct [`IR`](@ref) or used to perform other reflection on the method.

See also [`@meta`](@ref).

    julia> IRTools.meta(Tuple{typeof(gcd),Int,Int})
    Metadata for gcd(a::T, b::T) where T<:Union{Int128, Int16, Int32, Int64, Int8, UInt128, UInt16, UInt32, UInt64, UInt8} in Base at intfuncs.jl:31
"""
function meta(T; types = T, world=nothing)
  if world === nothing
    # if the user didn't specify a world, use the current world,
    # or a spoofed world if we're executing a dynamo
    world = something(spoofed_world[], worldcounter())
  end
  F = T.parameters[1]
  F == typeof(invoke) && return invoke_meta(T; world = world)
  F isa DataType && (F.name.module === Core.Compiler ||
                     F <: Core.Builtin ||
                     F <: Core.Builtin) && return nothing
  min_world = Ref{UInt}(typemin(UInt))
  max_world = Ref{UInt}(typemax(UInt))
  has_ambig = Ptr{Int32}(C_NULL)  # don't care about ambiguous results
  _methods = Base._methods_by_ftype(T, #=mt=# nothing, #=lim=# -1,
                                    world, #=ambig=# false,
                                    min_world, max_world, has_ambig)
  _methods === nothing && return nothing
  _methods isa Bool && return nothing
  length(_methods) == 0 && return nothing
  type_signature, sps, method = last(_methods)
  sps = svec(map(untvar, sps)...)
  mi = Core.Compiler.specialize_method(method, types, sps)
  ci = hasgenerator(mi) ? get_staged(mi, world) : Base.uncompressed_ast(method)
  Base.Meta.partially_inline!(ci.code, [], method.sig, Any[sps...], 0, 0, :propagate)
  Meta(method, mi, ci, method.nargs, sps)
end

function invoke_tweaks!(ci::CodeInfo)
  if ci.slottypes !== nothing
    ci.slottypes = [typeof(invoke), ci.slottypes[1], Type, ci.slottypes[2:end]...]
  end
  ci.slotnames = [:invoke, ci.slotnames[1], :T, ci.slotnames[2:end]...]
  ci.slotflags = [0x00, ci.slotflags[1], 0x00, ci.slotflags[2:end]...]
  ci.code = map(ci.code) do x
    prewalk(x) do x
      x isa SlotNumber ? SlotNumber(x.id == 1 ? 2 : x.id+2) : x
    end
  end
end

function invoke_meta(T; world)
  F = T.parameters[2]
  A = T.parameters[3]::Type{<:Type{<:Tuple}}
  S = T.parameters[4:end]
  T = Tuple{F,A.parameters[1].parameters...}
  S = Tuple{F,S...}
  m = meta(T, types = S, world = world)
  invoke_tweaks!(m.code)
  return Meta(m.method, m.instance, m.code, m.nargs+2, m.sparams)
end

"""
    @meta [world] f(args...)

Convenience macro for retrieving metadata without writing a full type signature.

    julia> IRTools.@meta gcd(10, 5)
    Metadata for gcd(a::T, b::T) where T<:Union{Int128, Int16, Int32, Int64, Int8, UInt128, UInt16, UInt32, UInt64, UInt8} in Base at intfuncs.jl:31
"""
macro meta(ex...)
  if length(ex) == 1
    world = nothing
    call = ex[1]
  elseif length(ex) == 2
    world, call = ex
  else
    error("@meta [world] f(args...)")
  end
  isexpr(call, :call) || error("@meta [world] f(args...)")
  f, args = call.args[1], call.args[2:end]
  :(meta(typesof($(esc.((f, args...))...)); world=$(esc(world))))
end

function code_ir(f, T)
  m = meta(Tuple{Typeof(f),T.parameters...})
  return IR(m)
end

function code_irm(ex)
  if isexpr(ex, :call)
    f, args = ex.args[1], ex.args[2:end]
  elseif isexpr(ex, :do)
    f, args = ex.args[1].args[1], vcat(ex.args[2], ex.args[1].args[2:end])
  else
    error("@code_ir f(args...)")
  end
  :($code_ir($(esc(f)), typesof($(esc.(args)...))))
end

"""
    @code_ir f(args...)

Convenience macro similar to `@code_lowered` or `@code_typed`. Retrieves the IR
for the given function call.

    julia> @code_ir gcd(10, 5)
    1: (%1, %2, %3)
      %4 = %2 == 0
      br 4 unless %4
    2: ...
"""
macro code_ir(ex)
  code_irm(ex)
end

codeinfo(m::Meta) = m.code

function argnames!(meta, names...)
  meta.code.slotnames = [names...]
end

import Base: show

# TODO: real expression printing
function Base.show(io::IO, x::Variable)
  bs = get(io, :bindings, Dict())
  haskey(bs, x) ? print(io, bs[x]) : print(io, "%", x.id)
end

print_stmt(io::IO, ex::Expr) = print_stmt(io::IO, Val(ex.head), ex)
print_stmt(io::IO, ::Val, ex) = print(io, ex)
print_stmt(io::IO, ex) = print(io, ex)

function show(io::IO, b::Branch)
  if b == unreachable
    print(io, "unreachable")
  elseif isreturn(b)
    print(io, "return ", b.args[1])
  else
    print(io, "br $(b.block)")
    if !isempty(b.args)
      print(io, " (")
      join(io, b.args, ", ")
      print(io, ")")
    end
    b.condition != nothing && print(io, " unless $(b.condition)")
  end
end

const tab = "  "

function printargs(io::IO, args, types = [Any for arg in args])
  print(io, "(")
  for i = 1:length(args)
    print(io, args[i])
    types[i] != Any && print(io, " :: ", types[i])
    i != length(args) && print(io, ", ")
  end
  print(io, ")")
end

function show(io::IO, b::Block)
  indent = get(io, :indent, 0)
  bs = get(io, :bindings, Dict())
  bb = BasicBlock(b)
  print(io, tab^indent)
  print(io, b.id, ":")
  if !isempty(bb.args)
    print(io, " ")
    printargs(io, bb.args, bb.argtypes)
  end
  for (x, st) in b
    haskey(bs, x) && continue
    println(io)
    print(io, tab^indent, "  ")
    x == nothing || print(io, string("%", x.id), " = ")
    st.expr == nothing ? print(io, "nothing") :
      print_stmt(io, st.expr)
    st.type == Any || print(io, " :: ", st.type)
  end
  for br in bb.branches
    println(io)
    print(io, tab^indent, "  ", br)
  end
end

function show(io::IO, ir::IR)
  show(io, block(ir, 1))
  for b in blocks(ir)[2:end]
    println(io)
    show(io, b)
  end
end

function print_stmt(io::IO, ex::IR)
  io = IOContext(io, :indent=>get(io, :indent, 0)+2)
  println(io)
  show(io, ex)
end

function print_stmt(io::IO, ::Val{:enter}, ex)
  print(io, "try #$(ex.args[1])")
  if length(ex.args) >= 2
      print(io, " with scope ", ex.args[2])
  end
end

function print_stmt(io::IO, ::Val{:leave}, ex)
  print(io, "end try")
end

function print_stmt(io::IO, ::Val{:catch}, ex)
  print(io, "catch $(ex.args[1])")
  args = ex.args[2:end]
  if !isempty(args)
    print(io, " (")
    join(io, args, ", ")
    print(io, ")")
  end
end

function print_stmt(io::IO, ::Val{:pop_exception}, ex)
  print(io, "pop exception $(ex.args[1])")
end

function lambdacx(io, ex)
  bs = get(io, :bindings, Dict())
  ir = ex.args[1]
  args = ex.args[2:end]
  bs′ = Dict()
  for (v, st) in ir
    ex = st.expr
    if iscall(ex, GlobalRef(Base, :getindex)) &&
        ex.args[2] == arguments(ir)[1] &&
        ex.args[3] isa Integer
      x = args[ex.args[3]]
      bs′[v] = string(get(bs, x, x), "'")
    end
  end
  return bs′
end

function print_stmt(io::IO, ::Val{:lambda}, ex)
  print(io, "λ :")
  # printargs(io, ex.args[2:end])
  io = IOContext(io, :indent   => get(io, :indent, 0)+2,
                     :bindings => lambdacx(io, ex))
  println(io)
  print(io, ex.args[1])
end

# Implementation of the amb operator using shift/reset
# http://community.schemewiki.org/?amb

include("continuations.jl");

struct Backtrack end

function require(x)
  x || throw(Backtrack())
  return
end

unwrap(e) = e
unwrap(e::CapturedException) = e.ex

function amb(iter)
  shift() do k
    for x in iter
      try
        return k(x)
      catch e
        unwrap(e) isa Backtrack || rethrow()
      end
    end
    throw(Backtrack())
  end
end

function ambrun(f)
  try
    @reset f()
  catch e
    e isa Backtrack || rethrow()
    error("No possible combination found.")
  end
end

ambrun() do
  x = amb([1, 2, 3])
  y = amb([1, 2, 3])
  require(x^2 + y == 7)
  (x, y)
end

ambrun() do
  N = 20
  i = amb(1:N)
  j = amb(i:N)
  k = amb(j:N)
  require(i*i + j*j == k*k)
  (i, j, k)
end

using IRTools, Test
using IRTools: IR, @dynamo

function f(x)
    N = 4
    for i1 in 1:3    # single loop works without issue
        for i2 in 1:N   # needs to be a variable `1:4` works fine
        end
    end
    0.0 # same error with `x`
end

@test @code_ir(f(1)) isa IR

function f(a, b)
    u = 1
    while true
        if true
        end
    end
    f(u)
end

@test @code_ir(f(1, 2)) isa IR

# issue 30
@dynamo function foo(a...)
    ir = IR(a...)
    return ir
end

mylog2(x) = ccall((:log2, Base.Math.libm), Float64, (Float64,), x)

@test foo(mylog2, 3.3) === mylog2(3.3)

bar(a, b) = a > b ? a : b

function foo(a, b)
  bar(a, b)
end

let
  ir1 = @code_ir foo(1, 2)
  ir2 = @code_ir bar(1, 2)
  inline_at = findfirst(ir1) do (_, stmt)
    IRTools.isexpr(stmt.expr, :call) &&
      stmt.expr.args[1] == GlobalRef(@__MODULE__, :bar)
  end
  @test inline_at !== nothing
  ir = IRTools.inline(ir1, inline_at, ir2)
  f = IRTools.func(ir)
  # `invokelatest` is needed because `func` defines the method in a world newer
  # than the one this `let` block executes in.
  @test Base.invokelatest(f, nothing, 2, 3) == 3
  @test Base.invokelatest(f, nothing, 3, 2) == 3
end

function foo1(x)
  while x < 10
    x += 1
  end
  return x
end

function foo2(x)
  if x < 100
    x + foo1(x)
  else
    x
  end
end

let
  ir = @code_ir foo2(1)
  ir2 = @code_ir foo1(1)
  inline_at = findfirst(ir) do (_, stmt)
    IRTools.isexpr(stmt.expr, :call) &&
      stmt.expr.args[1] == GlobalRef(@__MODULE__, :foo1)
  end
  @test inline_at !== nothing
  ir3 = IRTools.inline(ir, inline_at, ir2)
  f = IRTools.func(ir3)
  @test Base.invokelatest(f, nothing, 2) == 12
  @test Base.invokelatest(f, nothing, 101) == 101
end


function foo1(x)
  while x < 10
    x += 1
  end
  return x
end

function foo2(x)
  foo1(x)
  x > 0 ? x : 0
end

let
  ir = @code_ir foo2(1)
  ir2 = @code_ir foo1(1)
  inline_at = findfirst(ir) do (_, stmt)
    IRTools.isexpr(stmt.expr, :call) &&
      stmt.expr.args[1] == GlobalRef(@__MODULE__, :foo1)
  end
  @test inline_at !== nothing
  ir3 = IRTools.inline(ir, inline_at, ir2)
  f = IRTools.func(ir3)
  @test Base.invokelatest(f, nothing, 2) == foo2(2)
  @test Base.invokelatest(f, nothing, -2) == foo2(-2)
end

cond(c, t, f) = c ? t() : f()

allsuccs(ir, (id,chs)) =
  union(map(b -> b.id, successors(block(ir, id))),
        allsuccs.((ir,), chs)...)

function captures(ir, (id, chs), cs = Dict())
  bl = block(ir, id)
  captures.((ir,), chs, (cs,))
  cs[id] = setdiff(union([cs[i] for (i, _) in chs]..., usages(bl)), definitions(bl))
  return cs
end

function return_thunk(x)
  ir = IR()
  return!(ir, xcall(:getindex, argument!(ir), 1))
  Expr(:lambda, ir, x)
end

function br_thunk(args...)
  ir = IR()
  self = argument!(ir)
  return!(ir, xcall([xcall(:getindex, self, i) for i = 1:length(args)]...))
  Expr(:lambda, ir, args...)
end

function functionalbranches!(bl, pr, labels)
  if length(branches(bl)) == 1
    br = branches(bl)[1]
    if !isreturn(br)
      r = push!(pr, Expr(:call, labels[br.block], br.args...))
      empty!(branches(pr.to))
      return!(pr, r)
    end
  else
    @assert length(branches(bl)) == 2
    f, t = branches(bl)
    function brfunc(br)
      isreturn(br) && return return_thunk(returnvalue(br))
      isempty(arguments(br)) && return labels[br.block]
      br_thunk(labels[br.block], arguments(br)...)
    end
    r = push!(pr, xcall(IRTools, :cond, f.condition, brfunc(t), brfunc(f)))
    empty!(branches(pr.to))
    return!(pr, r)
  end
end

function _functional(ir, tree, vars = [], cs = captures(ir, tree))
  id = tree[1]
  bl = IR(block(ir, id))
  labels = Dict()
  labels[id] = self = id == 1 ? arguments(bl)[1] : argument!(bl, at = 1)
  pr = Pipe(bl)
  for (i, v) in enumerate(vars)
    v′ = push!(pr, xcall(:getindex, self, i))
    v isa Integer ? (labels[v] = v′) : substitute!(pr, v, substitute(pr, v′))
  end
  for _ in pr end
  for t in reverse(tree[2])
    bs = filter(id -> haskey(labels, id), allsuccs(ir, t))
    λ = Expr(:lambda, _functional(ir, t, [bs..., cs[t[1]]...]),
             map(b -> labels[b], bs)..., cs[t[1]]...)
    labels[t[1]] = push!(pr, λ)
  end
  functionalbranches!(bl, pr, labels)
  return finish(pr)
end

functional(ir) = _functional(explicitbranch!(ir), domtree(ir))

using IRTools, Documenter, Test

@testset "IRTools" begin

@testset "IR" begin
  include("ir.jl")
end

@testset "Analysis" begin
  include("analysis.jl")
end

@testset "Reflection" begin
  include("reflection.jl")
end

@testset "Compiler" begin
  include("compiler.jl")
end

@testset "Relooper" begin
  include("relooper.jl")
end

# Doctests print Julia IR, whose exact form is compiler-version-specific, so
# only run them on the minimum supported Julia version (matching the docs CI job).
if v"1.10" <= VERSION < v"1.11"
    doctest(IRTools)
end

end

module IRTools

export @code_ir

module Inner

  using MacroTools
  using MacroTools: @q, prewalk, postwalk
  import ..IRTools

  export @code_ir

  @nospecialize

  include("reflection/reflection.jl")
  include("utils.jl")

  include("ir/ir.jl")
  include("ir/utils.jl")
  include("ir/wrap.jl")
  include("ir/print.jl")
  include("ir/parse.jl")

  include("reflection/utils.jl")
  include("reflection/dynamo.jl")

  include("passes/passes.jl")
  include("passes/inline.jl")
  include("passes/cps.jl")
  include("passes/relooper.jl")
  include("passes/stackifier.jl")
  include("passes/registers.jl")

  include("interpret.jl")
  include("eval.jl")

end

let exports = :[
      # IR
      IRTools, IR, Block, BasicBlock, Variable, Statement, Branch, Pipe, CFG, Slot, branch, var, stmt, arguments, argtypes,
      branches, undef, unreachable, isreturn, isconditional, block!, deleteblock!, branch!, argument!, return!,
      canbranch, returnvalue, returntype, emptyargs!, deletearg!, block, blocks, successors, predecessors,
      xcall, exprtype, exprline, isexpr, insertafter!, explicitbranch!, prewalk, postwalk,
      prewalk!, postwalk!, finish, substitute!, substitute,
      # Passes/Analysis
      definitions, usages, dominators, domtree, domorder, domorder!, renumber,
      merge_returns!, expand!, prune!, ssa!, inlineable!, log!, pis!, func, evalir,
      Simple, Loop, Multiple, reloop, stackify, functional, cond, WorkQueue,
      Graph, liveness, interference, colouring, inline,
      # Reflection, Dynamo
      Meta, Lambda, meta, dynamo, transform, refresh, recurse!, self,
      varargs!, slots!,
      ].args
  append!(exports, Symbol.(["@code_ir", "@dynamo", "@meta"]))
  for x in exports
    @eval const $x = Inner.$x
  end
  @eval module All
    $([:(import ..IRTools: $x) for x in exports]...)
    export $(exports...)
  end
end

end # module

import Base: push!, insert!, getindex, setindex!, iterate, length

# We have our own versions of these in order to
# (1) be more robust to Base IR changes, and
# (2) make sure that mistakes/bugs do not cause bad LLVM IR.

"""
    LineInfoNode(file::Symbol, line::Int32, [inlined_at::Int32])

Represents line information about a statement; Inlined statements has a non-zero
`inlined_at` which represents the "parent" location in the linetable array.
"""
struct LineInfoNode
  file::Symbol
  line::Int32
  inlined_at::Int32
end
LineInfoNode(file, line) = LineInfoNode(file, line, Int32(0))

struct Undefined end
const undef = Undefined()

"""
    Variable(id::Integer)
    var(id::Integer)

Represents an SSA variable. Primarily used as an index into `IR` objects.
"""
struct Variable
  id::Int
end

var(id::Integer) = Variable(id)



"""
    Branch(condition::Any, block::Int, args::Vector{Any})

Represents a generalized branching instruction, consisting of a `condition` (usually a `Variable` of
boolean type), a target `block`, and a vector of `args` passed to the jump target.  There are three
types of branches that exist by the following convention:

- A return branch is represented by `Branch(nothing, 0, [<return value>])`.
- An unconditional branch is represented by `Branch(nothing, <target>, [<optional arguments ...>])`
- A conditional branch is represented by `Branch(<condition>, <target>, [<optional arguments ...>])`

See also: [`branch!`](@branch!), [`return!`](@return), [`isreturn`](@isreturn),
[`isconditional`](@isconditional)
"""
struct Branch
  condition::Any
  block::Int
  args::Vector{Any}
end

Branch(br::Branch; condition = br.condition,
                   block = br.block, args = br.args) =
  Branch(condition, block, args)

"""
    isreturn(br::Branch)

Check whether `br` has the form of a return branch (see [`Branch`](@Branch)).
"""
isreturn(b::Branch) = b.block == 0 && length(b.args) == 1

"""
    returnvalue(b::Branch)

Get the return value of `b` (the first argument of the branch).
"""
returnvalue(b::Branch) = b.args[1]

"""
    isconditional(br::Branch)

Check whether `br` has the form of a conditional branch (see [`Branch`](@Branch)).
"""
isconditional(b::Branch) = b.condition != nothing

Base.:(==)(a::Branch, b::Branch) =
  (a.condition, a.block, a.args) == (b.condition, b.block, b.args)

Base.copy(br::Branch) = Branch(br.condition, br.block, copy(br.args))

"""
    arguments(br::Branch)

Return the argument vector of the branch `br`.  (These are the arguments passed to a jumped-to
block.)
"""
arguments(b::Branch) = b.args

const unreachable = Branch(nothing, 0, [])



"""
    Statement(expr; type, line)
    stmt(expr; type, line)

Represents a single statement in the IR. The `expr` is a non-nested Julia
expression (`Expr`). `type` represents the return type of the statement; in most
cases this can be ignored and defaults to `Any`. `line` represents the source
location of the statement; it is an integer index into the IR's line table.

As a convenience, if `expr` is already a statement, the new statement will
inherit its type and line number.
"""
struct Statement
  expr::Any
  type::Any
  line::Int
end

Statement(x; expr = x, type = Any, line = 0) =
  Statement(expr, type, line)

"""
    Statement(stmt::Statement; expr, type, line)

Copy of `stmt` with optionally updated fields.
"""
Statement(x::Statement; expr = x.expr, type = x.type, line = x.line) =
  Statement(expr, type, line)

const stmt = Statement


"""
    BasicBlock(stmts::Vector{Statement}, args::Vector{Any},
               argtypes::Vector{Any}, branches::Vector{Branch})
    BasicBlock([stmts])

Represents a [basic
block](https://en.wikipedia.org/wiki/Static_single_assignment_form#Converting_to_SSA) of code in
SSA form.  A block consists of a list of statements, followed by optional branching instructions and
arguments, with optional types.
"""
struct BasicBlock
    stmts::Vector{Statement}
    args::Vector{Any}
    argtypes::Vector{Any}
    branches::Vector{Branch}
end

BasicBlock(stmts = []) = BasicBlock(stmts, [], [], Branch[])

Base.copy(bb::BasicBlock) = BasicBlock(copy(bb.stmts), copy(bb.args), copy(bb.argtypes), copy.(bb.branches))

"""
    branches(bb::BasicBlock)

Return the vector of branching instructions in block `bb`.
"""
branches(bb::BasicBlock) = bb.branches

"""
    arguments(bb::BasicBlock)

Return the argument vector of the basic block `bb`.  (These are the arguments given by the branch
to this block.)
"""
arguments(bb::BasicBlock) = bb.args

"""
    argtypes(bb::BasicBlock)

Return the argument types of the basic block `bb`.  (These are the arguments given by the branch
to this block.)
"""
argtypes(bb::BasicBlock) = bb.argtypes

"""
    IR()
    IR(metadata; slots = false)

Represents a fragment of SSA-form code.

IR can be constructed from scratch, but more usually an existing Julia method is
used as a starting point (see [`meta`](@ref) for how to get metadata for a
method). The `slots` argument determines whether the IR preserves mutable
variable slots; by default, these are converted to SSA-style variables.

As a shortcut, IR can be constructed directly from a type signature, e.g.

    julia> IR(typeof(gcd), Int, Int)
    1: (%1, %2, %3)
      %4 = %2 == 0
      br 4 unless %4
    2: ...

See also: [`code_ir`](@code_ir)
"""
struct IR
  defs::Vector{Tuple{Int,Int}}
  blocks::Vector{BasicBlock}
  lines::Vector{LineInfoNode}
  meta::Any
end

IR(; meta = nothing) = IR([],[BasicBlock()],[],meta)
IR(lines::Vector{LineInfoNode}; meta = nothing) = IR([],[BasicBlock()],lines,meta)

Base.copy(ir::IR) = IR(copy(ir.defs), copy.(ir.blocks), copy(ir.lines), ir.meta)

length(ir::IR) = sum(x -> x[2] > 0, ir.defs, init = 0)

"""
    block!(ir::IR)
    block!(ir::IR, i)

Insert a new block in `ir`.  If `i` is given, the block is inserted at this position, otherwise it
is appended at the end.  Branches in all other blocks are updated to preserve the original
behaviour.
"""
function block!(ir::IR, i = length(blocks(ir))+1)
  insert!(ir.blocks, i, BasicBlock())
  if i != length(blocks(ir))
    for b in blocks(ir), bi = 1:length(branches(b))
      br = branches(b)[bi]
      br.block >= i && (branches(b)[bi] = Branch(br, block = br.block+1))
    end
    for (ii, (b, j)) = enumerate(ir.defs)
      b >= i && (ir.defs[ii] = (b+1, j))
    end
  end
  return block(ir, i)
end

"""
    deleteblock!(ir::IR, i)

Delete the block at position `i`.  Branches in all other blocks are updated to preserve the original
behaviour.
"""
function deleteblock!(ir::IR, i::Integer)
  deleteat!(ir.blocks, i)
  if i != length(blocks(ir))+1
    for b in blocks(ir), bi = 1:length(branches(b))
      br = branches(b)[bi]
      br.block >= i && (branches(b)[bi] = Branch(br, block = br.block-1))
    end
  end
  for (ii, (b, j)) = enumerate(ir.defs)
    b == i && (ir.defs[ii] = (-1, -1))
    b > i && (ir.defs[ii] = (b-1, j))
  end
  return
end

struct Block
  ir::IR
  id::Int
end


BasicBlock(b::Block) = b.ir.blocks[b.id]
branches(b::Block) = branches(BasicBlock(b))

branches(ir::IR) = length(blocks(ir)) == 1 ? branches(block(ir, 1)) :
  error("IR has multiple blocks, so `branches(ir)` is ambiguous.")

arguments(b::Block) = arguments(BasicBlock(b))
arguments(ir::IR) = arguments(block(ir, 1))

argtypes(b::Block) = argtypes(BasicBlock(b))
argtypes(ir::IR) = argtypes(block(ir, 1))


"""
    canbranch(b::Block)

Check whether adding a branch to block `b` will be valid (i.e, the last existing branch is not
conditional).
"""
canbranch(b::Block) = length(branches(b)) == 0 || isconditional(branches(b)[end])

"""
    isreturn(b::Block)

Check whether the block `b` has a return branch.
"""
isreturn(b::Block) = any(isreturn, branches(b))

"""
    explicitbranch!(b::Block)
    explicitbranch!(ir::IR)

Convert implicit fallthroughs to explicit branches to the next block (these occur when the last
branch in a block is conditional):

    1: (%1, %2)
      %3 = %2 < 0
      br 3 unless %3
    2:
      return 0
    3:
      return %2

will become

    1: (%1, %2)
      %3 = %2 < 0
      br 3 unless %3
      br 2
    2:
      return 0
    3:
      return %2
"""
function explicitbranch!(b::Block)
  b.id == 1 && return
  a = block(b.ir, b.id-1)
  if all(isconditional, branches(a))
    branch!(a, b.id)
  end
  return b
end

explicitbranch!(ir::IR) = (foreach(explicitbranch!, blocks(ir)); return ir)

"""
    branches(b::Block, c::Block)

Return the vector of all branches from block `b` to block `c`.
"""
function branches(b::Block, c::Block)
  c.id == b.id+1 && explicitbranch!(c)
  filter(br -> br.block == c.id, branches(b))
end

branches(b::Block, c::Integer) = branches(b, block(b.ir, c))


"""
    returnvalue(b::Block)

Retreive the return value of a block.

    julia> f(x) = 3x + 2;

    julia> IRTools.block(@code_ir(f(1)), 1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> IRTools.returnvalue(ans)
    %4
"""
function returnvalue(b::Block)
  isreturn(branches(b)[end]) || error("Block does not return")
  return returnvalue(branches(b)[end])
end

"""
    returnvalue(b::Block)

Retreive the return type of a block.
"""
returntype(b::Block) = exprtype(b.ir, returnvalue(b))

"""
    argument!(block, [value, type]; at, insert)
    argument!(ir, [value, type]; at, insert)

Create a new argument for the given block / IR fragment, and return the variable
representing the argument.

    julia> ir = IR();

    julia> argument!(ir)
    %1

    julia> ir
    1: (%1)

The `at` keyword argument can be used to specify where the new argument should
go; by default it is appended to the end of the argument list.

Unless `insert = false`, if there are branches to this block, they will be updated to pass `value`
(`nothing` by default) as an argument (by default, `insert = true`).
"""
function argument!(b::Block, value = nothing, t = Any;
                   insert = true, at = length(arguments(b))+1, type = t)
  if at < length(arguments(b))
    for i = 1:length(b.ir.defs)
      (c, j) = b.ir.defs[i]
      c == b.id && -j >= at && (b.ir.defs[i] = (c, j-1))
    end
  end
  push!(b.ir.defs, (b.id, -at))
  arg = var(length(b.ir.defs))
  insert!(arguments(b), at, arg)
  insert!(BasicBlock(b).argtypes, at, type)
  if insert
    explicitbranch!(b)
    for c in blocks(b.ir), br in branches(c)
      br.block == b.id && insert!(arguments(br), at, value)
    end
  end
  return arg
end

argument!(ir::IR, a...; kw...) =
  argument!(block(ir, 1), nothing, a...; kw..., insert = false)


"""
    emptyargs!(b::Block)

Delete all arguments from block `b`, and automatically remove them from all
branches to this block.
"""
function emptyargs!(b::Block)
  empty!(arguments(b))
  for c in blocks(b.ir), br in branches(c)
    br.block == b.id && empty!(arguments(br))
  end
  return
end

"""
    deletearg!(b::Block, i::Integer)

Delete the `i`-th argument from block `b`, and automatically remove it from all
branches to this block.
"""
function deletearg!(b::Block, i::Integer)
  arg = arguments(b)[i]
  deleteat!(arguments(b), i)
  deleteat!(argtypes(b), i)
  for c in blocks(b.ir), br in branches(c)
    br.block == b.id && deleteat!(arguments(br), i)
  end
  b.ir.defs[arg.id] = (-1, -1)
  for arg in arguments(b)[i:end]
    (bl, pos) = b.ir.defs[arg.id]
    b.ir.defs[arg.id] = (bl, pos+1)
  end
  return
end

function deletearg!(b::Block, i::AbstractVector)
  for i in sort(i, lt = >)
    deletearg!(b, i)
  end
end

"""
    deletearg!(ir::IR, i)

Delete the `i`-th argument from the first block of `ir`, and automatically remove it from all
branches to this block.
"""
deletearg!(ir::IR, i) = deletearg!(block(ir, 1), i)

"""
    block(ir, i)

Return the `i`-th `Block` of `ir`.
"""
block(ir::IR, i) = Block(ir, i)
block(ir::IR, v::Variable) = blockidx(ir, v)[1]

"""
    blocks(ir)

Return the list of blocks `Block` of `ir`.
"""
blocks(ir::IR) = [block(ir, i) for i = 1:length(ir.blocks)]

function blockidx(ir::IR, x::Variable)
  b, i = get(ir.defs, x.id, (-1, -1))
  i > 0 || error("No such variable $x")
  block(ir, b), i
end

"""
    haskey(ir, var)

Check whether the variable `var` was defined in `ir`.

    julia> f(x) = 3x + 2;

    julia> ir = @code_ir f(1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> haskey(ir, var(3))
    true

    julia> haskey(ir, var(7))
    false
"""
function Base.haskey(ir::IR, x::Variable)
  b, i = get(ir.defs, x.id, (-1, -1))
  return i > 0
end

getindex(b::Block, i::Integer) = BasicBlock(b).stmts[i]
getindex(b::Block, i::Variable) = b.ir[i]
setindex!(b::Block, x::Statement, i::Integer) = (BasicBlock(b).stmts[i] = x)
setindex!(b::Block, x, i::Integer) = (b[i] = Statement(b[i], expr = x))

branch(block::Integer, args...; unless = nothing) =
  Branch(unless, block, Any[args...])

branch(block::Block, args...; kw...) = branch(block.id, args...; kw...)

"""
    branch!(b::Block, block, args...; unless = nothing)

Add to block `b` a new branch to `block`, with arguments `args` and condition `unless`,
and return it.
"""
function branch!(b::Block, block, args...; unless = nothing)
  brs = branches(b)
  unless === nothing && deleteat!(brs, findall(br -> br.condition === nothing, brs))
  args = map(a -> a isa Expr ? push!(b, a) : a, args)
  push!(brs, branch(block, args...; unless = unless))
  return b
end

"""
    branch!(ir::IR, block, args...; unless = nothing)

Add to the last block of `ir` a new branch to `block`, with arguments `args` and condition `unless`,
and return it.
"""
function branch!(ir::IR, args...; kw...)
  branch!(blocks(ir)[end], args...; kw...)
  return ir
end


"""
    return!(block, x)
    return!(ir, x)

Add to `block` or the last block of `ir` a return branch with argument `x`, and return it.
"""
return!(ir, x) = branch!(ir, 0, x)

function getindex(ir::IR, i::Variable)
  b, i = blockidx(ir, i)
  return b[i]
end

Base.get(ir::IR, i::Variable, default) = haskey(ir, i) ? ir[i] : default

function setindex!(ir::IR, x, i::Variable)
  b, i = blockidx(ir, i)
  b[i] = x
end

setindex!(b::Block, x, i::Variable) = setindex!(b.ir, x, i)

function Base.delete!(ir::IR, i::Variable)
  ir[i] = nothing
  ir.defs[i.id] = (-1, -1)
  return ir
end

Base.delete!(b::Block, i::Variable) = delete!(b.ir, i)

length(b::Block) = count(x -> x[1] == b.id, b.ir.defs)

"""
    successors(b::Block)

Returns all `Block`s from which you can reach `b` in one jump; basically, all x such that
`branches(x, b)` is non-empty.  Implicit jumps by fall-through are noticed as well.

See: [`predecessors`](@predecessors)
"""
function successors(b::Block)
  brs = BasicBlock(b).branches
  succs = Int[br.block for br in brs if br.block > 0]
  all(br -> br.condition != nothing, brs) && b.id < length(blocks(b.ir)) && push!(succs, b.id+1)
  return [block(b.ir, succ) for succ in succs]
end

"""
    predecessors(b::Block)

Returns all `Block`s of which `b` is a successor; basically, all x such that
`branches(x, b)` is non-empty.  Implicit jumps by fall-through are noticed as well.

See: [`successors`](@successors)
"""
predecessors(b::Block) = [c for c in blocks(b.ir) if b in successors(c)]

"""
    keys(ir)

Return the variable keys for all statements defined in `ir`.

    julia> f(x) = 3x + 2;

    julia> ir = @code_ir f(1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> keys(ir)
    2-element Array{IRTools.Variable,1}:
     %3
     %4
"""
Base.keys(b::Block) = first.(sort([Variable(i) => v for (i, v) in enumerate(b.ir.defs) if v[1] == b.id && v[2] > 0], by = x->x[2]))

function iterate(b::Block, (ks, i) = (keys(b), 1))
  i > length(ks) && return
  return (ks[i]=>b.ir[ks[i]], (ks, i+1))
end

Base.keys(ir::IR) = first.(sort([Variable(i) => v for (i, v) in enumerate(ir.defs) if v[2] > 0], by = x->x[2]))

function iterate(ir::IR, (ks, i) = (keys(ir), 1))
  i > length(ks) && return
  return (ks[i]=>ir[ks[i]], (ks, i+1))
end

applyex(f, x) = x
applyex(f, x::Expr) =
  Expr(x.head, [x isa Expr ? f(x) : x for x in x.args]...)
applyex(f, x::Statement) = Statement(x, expr = applyex(f, x.expr))

"""
    push!(ir, x)

Append the statement or expression `x` to the IR or block `ir`, returning the
new variable. See also [`pushfirst!`](@ref), [`insert!`](@ref).

    julia> ir = IR();

    julia> x = argument!(ir)
    %1

    julia> push!(ir, xcall(:*, x, x))
    %2

    julia> ir
    1: (%1)
      %2 = %1 * %1
"""
function push!(b::Block, x::Statement)
  if !isexpr(x.expr, :foreigncall) # needed to avoid https://github.com/MikeInnes/IRTools.jl/issues/30
    x = applyex(a -> push!(b, Statement(x, expr = a)), x)
  end
  x = Statement(x)
  push!(BasicBlock(b).stmts, x)
  push!(b.ir.defs, (b.id, length(BasicBlock(b).stmts)))
  return Variable(length(b.ir.defs))
end

push!(b::Block, x) = push!(b, Statement(x))

push!(b::Block, x::Variable) = x

# TODO make this work on nested Exprs.
function insert!(b::Block, idx::Integer, x)
  insert!(BasicBlock(b).stmts, idx, Statement(x))
  for i = 1:length(b.ir.defs)
    c, j = b.ir.defs[i]
    if c == b.id && j >= idx
      b.ir.defs[i] = (c, j+1)
    end
  end
  push!(b.ir.defs, (b.id, idx))
  return Variable(length(b.ir.defs))
end

Base.pushfirst!(b::Block, x) = insert!(b, 1, x)

push!(ir::IR, x) = push!(block(ir, length(ir.blocks)), x)

"""
    pushfirst!(ir, x)

Insert the expression or statement `x` into the given IR or block at the
beginning, returning the new variable. See also [`push!`](@ref),
[`insert!`](@ref).

    julia> f(x) = 3x + 2
    f (generic function with 1 method)

    julia> ir = @code_ir f(1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> pushfirst!(ir, :(println("hello, world")))
    %5

    julia> ir
    1: (%1, %2)
      %5 = println("hello, world")
      %3 = 3 * %2
      %4 = %3 + 2
      return %4
"""
Base.pushfirst!(ir::IR, x) = pushfirst!(block(ir, 1), x)

"""
    insert!(ir, v, x)

Insert the expression or statement `x` into the given IR, just before the
variable `v` is defined, returning the new variable for `x`. See also
[`insertafter!`](@ref).

    julia> f(x) = 3x + 2
    f (generic function with 1 method)

    julia> ir = @code_ir f(1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> insert!(ir, IRTools.var(4), :(println("hello, world")))
    %5

    julia> ir
    1: (%1, %2)
      %3 = 3 * %2
      %5 = println("hello, world")
      %4 = %3 + 2
      return %4
"""
function insert!(ir::IR, i::Variable, x; after = false)
  if after && ir.defs[i.id][2] < 0
    pushfirst!(block(ir, ir.defs[i.id][1]), x)
  else
    b, i = blockidx(ir, i)
    insert!(b, i+after, x)
  end
end

insert!(b::Block, i::Variable, x; after = false) =
  insert!(b.ir, i, x; after = after)

"""
    insertafter!(ir, v, x)

Insert the expression or statement `x` into the given IR, just before the
variable `v` is defined, returning the new variable for `x`. See also
[`insert!`](@ref).

    julia> f(x) = 3x + 2
    f (generic function with 1 method)

    julia> ir = @code_ir f(1)
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      return %4

    julia> IRTools.insertafter!(ir, IRTools.var(4), :(println("hello, world")))
    %5

    julia> ir
    1: (%1, %2)
      %3 = 3 * %2
      %4 = %3 + 2
      %5 = println("hello, world")
      return %4
"""
insertafter!(ir, i, x) = insert!(ir, i, x, after=true)

"""
    empty(ir)

Create an empty IR fragment based on the given IR. The line number table and
any metadata are preserved from the original IR.

    julia> ir = empty(@code_ir gcd(10, 5))
    1:

    julia> ir.meta
    Metadata for gcd(a::T, b::T) where T<:Union{Int128, Int16, Int32, Int64, Int8, UInt128, UInt16, UInt32, UInt64, UInt8} in Base at intfuncs.jl:31
"""
Base.empty(ir::IR) = IR(copy(ir.lines), meta = ir.meta)

"""
    permute!(ir::IR, perm::AbstractVector)

Permutes block order in-place, keeping track of internal references (like branch targets).
"""
function Base.permute!(ir::IR, perm::AbstractVector)
  explicitbranch!(ir)
  permute!(ir.blocks, perm)
  iperm = invperm(perm)
  for v = 1:length(ir.defs)
    b, i = ir.defs[v]
    b == -1 && continue
    ir.defs[v] = (iperm[b], i)
  end
  for b in blocks(ir), i = 1:length(branches(b))
    branches(b)[i].block > 0 || continue
    br = branches(b)[i]
    branches(b)[i] = Branch(br, block = iperm[br.block])
  end
  return ir
end

function IR(b::Block)
  ir = IR(copy(b.ir.defs), [copy(BasicBlock(b))], b.ir.lines, b.ir.meta)
  for i in 1:length(ir.defs)
    if ir.defs[i][1] == b.id
      ir.defs[i] = (1, ir.defs[i][2])
    else
      ir.defs[i] = (-1, -1)
    end
  end
  return ir
end

# Pipe

struct NewVariable
  id::Int
end

"""
    Pipe(ir)

In general, it is not efficient to insert statements into IR; only appending is
fast, for the same reason as with `Vector`s.

For this reason, the `Pipe` construct makes it convenient to incrementally build
an new IR fragment from an old one, making efficient modifications as you go.

The general pattern looks like:

    pr = IRTools.Pipe(ir)
    for (v, st) in pr
      # do stuff
    end
    ir = IRTools.finish(pr)

Iterating over `pr` is just like iterating over `ir`, except that within the
loop, inserting and deleting statements in `pr` around `v` is efficient. Later,
`finish(pr)` converts it back to a normal IR fragment (in this case just a plain
copy of the original).
"""
mutable struct Pipe
  from::IR
  to::IR
  map::Dict{Any,Any}
  var::Int
  branch
  block
end

var!(p::Pipe) = NewVariable(p.var += 1)

substitute!(p::Pipe, x, y) = (p.map[x] = y; x)
substitute(p::Pipe, x::Union{Variable,NewVariable}) = p.map[x]
substitute(p::Pipe, x) = get(p.map, x, x)
substitute(p::Pipe, x::Statement) = stmt(x, expr = substitute(p, x.expr))
substitute(p::Pipe, x::Expr) = Expr(x.head, substitute.((p,), x.args)...)
substitute(p::Pipe) = x -> substitute(p, x)

function Pipe(ir)
  p = Pipe(ir, IR(copy(ir.lines), meta = ir.meta), Dict(), 0, identity, identity)
  for (x, T) in zip(p.from.blocks[1].args, p.from.blocks[1].argtypes)
    y = argument!(blocks(p.to)[end], nothing, T, insert = false)
    substitute!(p, x, y)
  end
  return p
end

function pipestate(ir::IR)
  ks = sort([Variable(i) => v for (i, v) in enumerate(ir.defs) if v[2] > 0], by = x->x[2])
  [first.(filter(x -> x[2][1] == b, ks)) for b = 1:length(ir.blocks)]
end

branches(f, p::Pipe) = (p.branch = f)
blocks(f, p::Pipe) = (p.block = f)

function iterate(p::Pipe, (ks, b, i) = (pipestate(p.from), 1, 1))
  i == 1 && b == 1 && p.block(b)
  if i == 1 && b != 1
    for (x, T) in zip(p.from.blocks[b].args, p.from.blocks[b].argtypes)
      y = argument!(blocks(p.to)[end], nothing, T, insert = false)
      substitute!(p, x, y)
    end
  end
  if i > length(ks[b])
    for br in branches(block(p.from, b))
      br′ = p.branch(br)
      br′ == nothing || push!(p.to.blocks[end].branches, map(substitute(p), br′))
    end
    b == length(ks) && return
    p.block(b)
    block!(p.to)
    return iterate(p, (ks, b+1, 1))
  end
  v = ks[b][i]
  st = p.from[v]
  substitute!(p, v, push!(p.to, substitute(p, st)))
  ((v, st), (ks, b, i+1))
end

finish(p::Pipe) = p.to

islastdef(ir::IR, v::Variable) =
  v.id == length(ir.defs) &&
  ir.defs[v.id] == (length(ir.blocks), length(ir.blocks[end].stmts))

setindex!(p::Pipe, x, v) = p.to[substitute(p, v)] = substitute(p, x)

function setindex!(p::Pipe, x::Variable, v)
  v′ = substitute(p, v)
  if islastdef(p.to, v′)
    delete!(p, v)
    substitute!(p, v, substitute(p, x))
  else
    p.to[v′] = substitute(p, x)
  end
end

function Base.push!(p::Pipe, x)
  tmp = var!(p)
  substitute!(p, tmp, push!(p.to, substitute(p, x)))
  return tmp
end

function Base.pushfirst!(p::Pipe, x)
  tmp = var!(p)
  substitute!(p, tmp, pushfirst!(p.to, substitute(p, x)))
  return tmp
end

function Base.delete!(p::Pipe, v)
  v′ = substitute(p, v)
  delete!(p.map, v)
  if islastdef(p.to, v′)
    pop!(p.to.defs)
    pop!(p.to.blocks[end].stmts)
  else
    delete!(p.to, v′)
  end
end

function insert!(p::Pipe, v, x; after = false)
  v′ = substitute(p, v)
  x = substitute(p, x)
  tmp = var!(p)
  if islastdef(p.to, v′) # we can make this case efficient by renumbering
    if after
      substitute!(p, tmp, push!(p.to, x))
    else
      substitute!(p, v, push!(p.to, p.to[v′]))
      p.to[v′] = Statement(x)
      substitute!(p, tmp, v′)
    end
  else
    substitute!(p, tmp, insert!(p.to, v′, x, after = after))
  end
  return tmp
end

argument!(p::Pipe, a...; kw...) =
  substitute!(p, var!(p), argument!(p.to, a...; kw...))

function branch!(ir::Pipe, b, args...; unless = nothing)
  args = map(a -> substitute(ir, a), args)
  cond = substitute(ir, unless)
  branch!(blocks(ir.to)[end], b, args...; unless = cond)
  return ir
end

function block!(p::Pipe)
  block!(p.to)
  return
end

function blockargument!(p::Pipe, type)
  x = argument!(blocks(p.to)[end], nothing, type, insert = false)
  substitute!(p, var!(p), x)
end

import Base: map, map!
import Core.Compiler: PhiNode, PiNode, ssamap, userefs
import MacroTools: walk, prewalk, postwalk

walk(x::PhiNode, inner, outer) =
  outer(PhiNode(x.edges,
                [inner(isassigned(x.values, i) ? x.values[i] : undef)
                 for i in 1:length(x.values)]))

walk(x::PiNode, inner, outer) = outer(PiNode(inner(x.val), x.typ))

xcall(mod::Module, f::Symbol, args...) = Expr(:call, GlobalRef(mod, f), args...)
xcall(f::Symbol, args...) = xcall(Base, f, args...)
xcall(f, args...) = Expr(:call, f, args...)

map(f, br::Branch) = Branch(br, condition = f(br.condition), args = f.(br.args))

function map(f, b::BasicBlock)
  stmts = map(x -> Statement(x, expr = f(x.expr)), b.stmts)
  branches = map(br -> map(f, br), b.branches)
  BasicBlock(stmts, b.args, b.argtypes, branches)
end

function map!(f, b::BasicBlock)
  map!(x -> Statement(x, expr = f(x.expr)), b.stmts, b.stmts)
  map!(br -> Branch(br, condition = f(br.condition), args = f.(br.args)), b.branches, b.branches)
  return b
end

function map!(f, b::Block)
  map!(f, BasicBlock(b))
end

function map(f, ir::IR)
  IR(ir.defs, map.(f, ir.blocks), ir.lines, ir.meta)
end

function map!(f, ir::IR)
  for b in blocks(ir)
    map!(f, b)
  end
  return ir
end

walk(st::Statement, inner, outer) = Statement(st, expr = inner(st.expr))
walk(bb::BasicBlock, inner, outer) = map(inner, bb)
walk(bb::Branch, inner, outer) = map(inner, bb)
walk(b::Block, inner, outer) = walk(BasicBlock(b), inner, outer)

walk(ir::IR, inner, outer) = outer(map(inner, ir))

# Avoid recursing into lambdas
prewalk(f, ir::Union{IR,Block})  = walk(f(ir), x -> x isa IR ? x : prewalk(f, x), identity)
postwalk(f, ir::Union{IR,Block}) = walk(ir, x -> x isa IR ? x : postwalk(f, x), f)

prewalk!(f, ir::Union{IR,Block})  = map!(x -> x isa IR ? x :  prewalk(f, x), ir)
postwalk!(f, ir::Union{IR,Block}) = map!(x -> x isa IR ? x : postwalk(f, x), ir)

varmap(f, x) = prewalk(x -> x isa Variable ? f(x) : x, x)

exprtype(x::GlobalRef; typeof = Typeof) = isconst(x.mod, x.name) ? typeof(getfield(x.mod, x.name)) : Any

exprtype(ir::IR, x::GlobalRef; typeof = Typeof) = exprtype(x, typeof = typeof)
exprtype(ir::IR, x::QuoteNode; typeof = Typeof) = typeof(x.value)
exprtype(ir::IR, x::Expr; typeof = Typeof) = error(x)
exprtype(ir::IR, x; typeof = Typeof) = typeof(x)

function exprtype(ir::IR, x::Variable; typeof = Typeof)
  b, i = get(ir.defs, x.id, (-1, -1))
  b == -1 && error("No such variable $x")
  if i > 0
    ir[x].type
  else
    ir.blocks[b].argtypes[-i]
  end
end

function exprline(ir::IR, x::Variable)
  b, i = get(ir.defs, x.id, (-1, -1))
  i > 0 || return
  get(ir.lines, ir[x].line, nothing)
end

using IRTools, Test
using IRTools: CFG, dominators, domtree

relu(x) = (y = x > 0 ? x : 0)
ir = @code_ir relu(1)

@test dominators(CFG(ir)) ==
  Dict(1 => Set([1]), 2 => Set([1, 2]), 3 => Set([1, 3]), 4 => Set([1, 4]))

@test domtree(CFG(ir)) == (1 => [2 => [], 3 => [], 4 => []])

@test domtree(CFG(ir)', entry = 4) == (4 => [1 => [], 2 => [], 3 => []])

using IRTools, Test
using IRTools: Meta, meta

@generated f(x) = :(x+x)

@test meta(Tuple{typeof(gcd),Int,Int}) isa Meta

@test meta(Tuple{typeof(f),Int}) isa Meta

# https://github.com/FluxML/IRTools.jl/issues/106
function g end
@test meta(Tuple{typeof(g),Int,Int}) === nothing
g(a) = 2a
@test meta(Tuple{typeof(g),Int,Int}) === nothing

@test @code_ir(map([1,2], [3,4]) do x, y
  x + y
end) isa IR

# A simple reverse-mode AD.
# Lots of simplifications have been made (in particular, there is no support for
# control flow). But this illustrates most of the principles behind Zygote.
# https://fluxml.ai/Zygote.jl/dev/internals/

using IRTools
using IRTools: @dynamo, IR, Pipe, finish, substitute, return!, block, blocks,
  returnvalue, arguments, isexpr, xcall, self, stmt

struct Pullback{S,T}
  data::T
end

Pullback{S}(data) where S = Pullback{S,typeof(data)}(data)

function primal(ir, T = Any)
  pr = Pipe(ir)
  calls = []
  ret = []
  for (v, st) in pr
    ex = st.expr
    if isexpr(ex, :call)
      t = insert!(pr, v, stmt(xcall(Main, :forward, ex.args...), line = st.line))
      pr[v] = xcall(:getindex, t, 1)
      J = push!(pr, xcall(:getindex, t, 2))
      push!(calls, v)
      push!(ret, J)
    end
  end
  pb = Expr(:call, Pullback{T}, xcall(:tuple, ret...))
  return!(pr, xcall(:tuple, returnvalue(block(ir, 1)), pb))
  return finish(pr), calls
end

_sum() = 0
_sum(x) = x
_sum(x...) = xcall(:+, x...)

function adjoint(pr)
  ir = empty(pr)
  grads = Dict()
  grad(x) = _sum(get(grads, x, [])...)
  grad(x, x̄) = push!(get!(grads, x, []), x̄)
  grad(returnvalue(block(pr, 1)), IRTools.argument!(ir))
  data = push!(ir, xcall(:getfield, self, QuoteNode(:data)))
  _, pbs = primal(pr)
  pbs = Dict(pbs[i] => push!(ir, xcall(:getindex, data, i)) for i = 1:length(pbs))
  for v in reverse(keys(pr))
    ex = pr[v].expr
    isexpr(ex, :call) || continue
    Δs = push!(ir, Expr(:call, pbs[v], grad(v)))
    for (i, x) in enumerate(ex.args)
      grad(x, push!(ir, xcall(:getindex, Δs, i)))
    end
  end
  return!(ir, xcall(:tuple, [grad(x) for x in arguments(pr)]...))
end

@dynamo function forward(m...)
  ir = IR(m...)
  ir == nothing && return :(error("Non-differentiable function ", repr(args[1])))
  length(blocks(ir)) == 1 || error("control flow is not supported")
  return primal(ir, Tuple{m...})[1]
end

@dynamo function (pb::Pullback{S})(Δ) where S
  return adjoint(IR(S.parameters...))
end

forward(::typeof(sin), x) = sin(x), ȳ -> (nothing, ȳ*cos(x))
forward(::typeof(cos), x) = cos(x), ȳ -> (nothing, -ȳ*sin(x))

gradient(f, x...) = Base.tail(forward(f, x...)[2](1))

foo(x) = sin(cos(x))

# ir = @code_ir foo(1.0)
# primal(ir)[1]
# adjoint(ir)

gradient(foo, 1.0)

struct CompileError
  transform
  args
  err
end

struct Self end
const self = Self()

# S -> function signature
# I -> lambda index
# T -> environment type
struct Lambda{S,I,T}
  data::T
end

Lambda{D,S}(data...) where {D,S} =
  Lambda{D,S,typeof(data)}(data)

@inline Base.getindex(l::Lambda, i::Integer) = l.data[i]

Base.show(io::IO, l::Lambda) = print(io, "λ")

function Base.showerror(io::IO, err::CompileError)
  println(io, "Error compiling @dynamo $(err.transform) on $(err.args):")
  showerror(io, err.err)
end

function transform end
function refresh end

function fallthrough(args...)
  Expr(:block,
       Expr(:meta, :inline),
       Expr(:call, [:(args[$i]) for i = 1:length(args)]...))
end

function lambdalift!(ir, S, I = ())
  i = 0
  for (v, st) in ir
    isexpr(st.expr, :lambda) || continue
    ir[v] = Expr(:call, Lambda{S,(I...,i+=1)}, st.expr.args[2:end]...)
  end
  return ir
end

function lambdaself!(ir, _self = self)
  for (v, st) in ir
    if isexpr(st.expr, :lambda)
      push!(st.expr.args, _self)
      λ = st.expr.args[1]
      s = pushfirst!(λ, xcall(:getindex, arguments(λ)[1], length(st.expr.args)-1))
      lambdaself!(λ, s)
    else
      ir[v] = prewalk(x -> x === self ? _self : x, st.expr)
    end
  end
  return ir
end

function getlambda(ir, I)
  isempty(I) && return ir
  i = 0
  for (v, st) in ir
    isexpr(st.expr, :lambda) || continue
    (i += 1) == I[1] && return getlambda(st.expr.args[1], Base.tail(I))
  end
  error("Something has gone wrong in IRTools; couldn't find lambda in IR")
end

# Used only for its CodeInfo
dummy(args...) = nothing

function dynamo(cache, world, f, args...)
  try
    # XXX: @dynamo should pass the world to the transform function, so that any
    #      IR look-ups are done in the correct world.
    spoofed_world[] = world
    ir = transform(f, args...)::Union{IR,Expr,Nothing}
  catch e
    rethrow(CompileError(f, args, e))
  finally
    spoofed_world[] = nothing
  end
  # TODO: how to set proper edges on the returned code info? we have to
  #       propagate the bounds from `methods_by_ftype`, but that lookup is
  #       done by `IRTools.meta` and is not available here.
  ir isa Expr && return ir
  ir == nothing && return fallthrough(args...)
  ir = lambdaself!(ir)
  cache[args] = ir
  ir = lambdalift!(copy(ir), Tuple{f,args...})
  if ir.meta isa Meta
    m = ir.meta
    ir = varargs!(m, ir)
    argnames!(m, :args)
    pushfirst!(m.code.slotnames, Symbol("#self#"))
  else
    m = @meta world dummy(1)
    m === nothing && error("Error looking up metadata for $f")
    m.code.method_for_inference_limit_heuristics = nothing
  end
  if isdefined(Base, :__has_internal_change) && Base.__has_internal_change(v"1.12-alpha", :codeinfonargs)
    m.code.nargs = 2
    m.code.isva = true
  end
  _self = splicearg!(ir)
  prewalk!(x -> x === self ? _self : x, ir)
  return update!(m.code, ir)
end

function dynamo_lambda(cache, world, f::Type{<:Lambda{S,I}}) where {S,I}
  ir = cache[(S.parameters[2:end]...,)]
  ir = getlambda(ir, I)
  ir = lambdalift!(copy(ir), S, I)
  closureargs!(ir)
  m = @meta world dummy(1)
  m.code.method_for_inference_limit_heuristics = nothing
  if isdefined(Base, :__has_internal_change) && Base.__has_internal_change(v"1.12-alpha", :codeinfonargs)
    m.code.nargs = 2
    m.code.isva = true
  end
  return update!(m.code, ir)
end

unesc(x) = prewalk(x -> isexpr(x, :escape) ? x.args[1] : x, x)

function lifttype(x)
  isexpr(x, :(::)) || return x
  named = length(x.args) == 2
  T = named ? x.args[2] : x.args[1]
  T = :(Type{$T})
  named ? Expr(:(::), x.args[1], T) : Expr(:(::), T)
end

const caches = Dict()

function dynamo_generator(world::UInt, source, self, args)
  cache = if haskey(caches, self)
    caches[self]
  else
    caches[self] = Dict()
  end

  ex = dynamo(cache, world, self, args...)
  ex isa Core.CodeInfo && return ex

  stub = Core.GeneratedFunctionStub(identity, Core.svec(:methodinstance, :args), Core.svec())
  stub(world, source, ex)
end

function dynamo_lambda_generator(world::UInt, source, self, args)
  f = self.parameters[1].parameters[1]
  cache = caches[f]

  ex = dynamo_lambda(cache, world, self)
  ex isa Core.CodeInfo && return ex

  stub = Core.GeneratedFunctionStub(identity, Core.svec(:methodinstance, :args), Core.svec())
  stub(world, source, ex)
end

macro dynamo(ex)
  @capture(shortdef(ex), (name_(args__) = body_) |
                         (name_(args__) where {Ts__} = body_)) ||
    error("@dynamo needs a function definition.")
  Ts = Ts == nothing ? [] : esc.(Ts)
  f, T = isexpr(name, :(::)) ?
    (length(name.args) == 1 ? (esc(gensym()), esc(name.args[1])) : esc.(name.args)) :
    (esc(gensym()), :(Core.Typeof($(esc(name)))))
  gendef = quote
    function ($f::$T)($(esc(:args))...) where $(Ts...)
      $(Expr(:meta, :generated, dynamo_generator))
      $(Expr(:meta, :generated_only))
    end
    function (f::IRTools.Inner.Lambda{<:Tuple{<:$T,Vararg{Any}}})(args...) where $(Ts...)
      $(Expr(:meta, :generated, dynamo_lambda_generator))
      $(Expr(:meta, :generated_only))
    end
  end
  quote
    $(isexpr(name, :(::)) || esc(:(function $name end)))
    function IRTools.transform(::Type{<:$T}, $(esc.(lifttype.(args))...)) where $(Ts...)
      $(esc(body))
    end
    $gendef
    IRTools.refresh(::$T) where $(Ts...) = (Core.eval($__module__, $(QuoteNode(unesc(gendef)))); return)
  end
end

macro code_ir(dy, ex)
  @capture(ex, f_(args__)) || error("@code_dynamo f(x...)")
  :(transform(typeof($(esc(dy))), meta($typesof($(esc(f)), $(esc.(args)...)))))
end

# TODO could support lambdas
function recurse!(ir, to = self)
  for (x, st) in ir
    isexpr(st.expr, :call) || continue
    ir[x] = Expr(:call, to, st.expr.args...)
  end
  return ir
end

function reaching(c::CFG, i::Integer, rs = Int[]; ignore = Int[])
  for j in c.graph[i]
    j in rs && return rs
    j in ignore && continue
    push!(rs, j)
    reaching(c, j, rs, ignore = ignore)
  end
  return rs
end

struct Simple
  block::Int
  next
end

Simple(n) = Simple(n, nothing)

struct Loop
  inner
  next
end

struct Multiple
  inner::Vector{Any}
  next
end

for T in [Simple, Loop, Multiple]
  @eval Base.:(==)(a::$T, b::$T) = $(reduce((a, b) -> :($a&&$b), [:(a.$f == b.$f) for f in fieldnames(T)]))
end

function reaches_unique(rs)
  rs = Dict(b => union(b, cs) for (b, cs) in rs)
  others(b) = union([cs for (c, cs) in rs if b != c]...)
  Dict(b => filter(c -> !any(rs -> c in rs, others(b)), cs) for (b, cs) in rs)
end

function reloop_loop(cfg::CFG, blocks, entry, done)
  rs = Dict(b => reaching(cfg, b, ignore = done) for b in blocks)
  body = filter(b -> any(e -> e in rs[b], entry), blocks)
  next = setdiff(blocks, body)
  Loop(reloop(cfg, blocks = body, entry = entry, done = union(done, entry)),
       reloop(cfg, blocks = next, entry = union([intersect(cfg[b], next) for b in body]...), done = done))
end

function reloop(cfg::CFG; blocks = 1:length(cfg.graph), entry = [1], done = Int[])
  (isempty(blocks) || isempty(entry)) && return
  rs = Dict(b => reaching(cfg, b, ignore = done) for b in entry)
  if length(entry) == 1 && entry[] ∉ rs[entry[]]
    next = setdiff(blocks, entry[])
    Simple(entry[],
           reloop(cfg, blocks = next,
                  entry = intersect(cfg.graph[entry[]], blocks), done = done))
  elseif all(b -> isempty(setdiff(entry, rs[b])), entry)
    reloop_loop(cfg, blocks, entry, done)
  elseif (rsu = reaches_unique(rs); !all(isempty, values(rsu)))
    unique = filter(b -> !isempty(rsu[b]), entry)
    inner = [reloop(cfg, blocks = union(b, rsu[b]), entry = [b], done = done) for b in unique]
    next = setdiff(blocks, union([union(b, rsu[b]) for b in unique]...))
    es = intersect(next, union(entry, reaching.((cfg,), unique)...))
    Multiple(inner, reloop(cfg, blocks = next, entry = es, done = done))
  else
    reloop_loop(cfg, blocks, entry, done)
  end
end

const indent = "  "

printstructure(io::IO, ::Nothing, level) = nothing

function printstructure(io::IO, s::Simple, level)
  println(io, indent^level, s.block)
  printstructure(io, s.next, level)
end

_printstructure(io::IO, s, level) = printstructure(io, s, level)

function _printstructure(io::IO, s::Simple, level)
  println(io, indent^level, "Simple:")
  printstructure(io, s, level+1)
end

function printstructure(io::IO, s::Multiple, level)
  println(io, indent^level, "Multiple:")
  if length(s.inner) == 1
    printstructure(io, s.inner[1], level+1)
  else
    for b in s.inner
      _printstructure(io, b, level+1)
    end
  end
  printstructure(io, s.next, level)
end

function printstructure(io::IO, s::Loop, level)
  println(io, indent^level, "Loop:")
  printstructure(io, s.inner, level+1)
  printstructure(io, s.next, level)
end

function Base.show(io::IO, b::Union{Simple,Multiple,Loop})
  println(io, "Structured CFG:")
  printstructure(io, b, 0)
end

# AST Conversion

rename(env, ex) =
  prewalk(x -> x isa Variable ? env[x] :
          x isa Slot ? Symbol(x.id) :
          x, ex)

entry(s::Simple) = [s.block]
entry(s::Loop) = entry(s.inner)
entry(s::Multiple) = union(entry.(s.inner)...)
entry(s::Nothing) = Int[]

struct ASTCtx
  ir::IR
  args::Dict{Variable,Symbol}
  branches::Dict{Any,Any}
  inline::Bool
end

function ast(cx::ASTCtx, b::Block)
  usages = Dict()
  prewalk(b) do x
    x isa Variable && (usages[x] = get(usages, x, 0)+1)
    x
  end
  exs = []
  env = Dict{Any,Any}(cx.args)
  for v in keys(b)
    ex = b[v].expr
    if cx.inline && get(usages, v, 0) == 1 && !(ex isa Slot) # TODO not correct
      env[v] = rename(env, ex)
    elseif get(usages, v, 0) == 0
      isexpr(ex) && push!(exs, rename(env, ex))
    else
      tmp = gensym("tmp")
      push!(exs, :($tmp = $(rename(env, ex))))
      env[v] = tmp
    end
  end
  return exs, env
end

ast(cx::ASTCtx, ::Nothing) = @q begin end

function ast(cx::ASTCtx, cfg::Simple)
  b = block(cx.ir, cfg.block)
  exs, env = ast(cx, b)
  function nextblock(br)
    if isreturn(br)
      @q (return $(rename(env, returnvalue(br)));)
    elseif haskey(cx.branches, br.block)
      cx.branches[br.block] == :continue && cfg.next == nothing ? @q(begin end) :
        @q ($(Expr(cx.branches[br.block]));)
    elseif cfg.next isa Multiple && br.block in entry(cfg.next)
      n = findfirst(i -> br.block in entry(i), cfg.next.inner)
      ast(cx, cfg.next.inner[n])
    elseif cfg.next isa Multiple && br.block in entry(cfg.next.next)
      ast(cx, cfg.next.next)
    elseif br.block in entry(cfg.next)
      ast(cx, cfg.next)
    else
      @q begin end
    end
  end
  @assert length(branches(b)) <= 2 "No more than 2 branches supported, currently."
  ex = if length(branches(b)) == 1
    @q begin
      $(exs...)
      $(nextblock(branches(b)[1]).args...)
    end
  else
    @q begin
      $(exs...)
      if $(rename(env, branches(b)[1].condition))
        $(nextblock(branches(b)[2]).args...)
      else
        $(nextblock(branches(b)[1]).args...)
      end
    end
  end
  cfg.next isa Multiple && (ex = @q ($(ex.args...); $(ast(cx, cfg.next.next).args...)))
  return ex
end

function ast(cx::ASTCtx, cfg::Multiple)
  error("Only structured control flow is currently supported.")
end

function ast(cx::ASTCtx, cfg::Loop)
  for e in entry(cfg)
    cx.branches[e] = :continue
  end
  for e in entry(cfg.next)
    cx.branches[e] = :break
  end
  brs = branches(block(cx.ir, cfg.inner.block))
  if length(brs) == 2 && brs[1].block in entry(cfg.next) && brs[2].block in entry(cfg.inner.next)
    exs, env = ast(cx, block(cx.ir, cfg.inner.block))
    cond = unblock(@q ($(exs...); $(rename(env, brs[1].condition))))
    @q begin
      while $cond
        $(ast(cx, cfg.inner.next).args...)
      end
      $(ast(cx, cfg.next).args...)
    end
  else
    @q begin
      while true
        $(ast(cx, cfg.inner).args...)
      end
      $(ast(cx, cfg.next).args...)
    end
  end
end

function reloop(ir::IR; inline = true)
  ir = explicitbranch!(copy(ir))
  cfg = reloop(CFG(ir))
  args = Dict(v => Symbol(:arg, i) for (i, v) in enumerate(arguments(ir)))
  ast(ASTCtx(ir, args, Dict(), inline), cfg)
end

# API Reference

This page provides a comprehensive reference for IRTools functionality.

## Reflection

```@docs
@code_ir
IRTools.meta
IRTools.@meta
```

## IR Manipulation

```@docs
IRTools.IR
IRTools.Statement
IRTools.Variable
IRTools.Branch
IRTools.BasicBlock
IRTools.arguments
IRTools.argtypes
IRTools.branches
IRTools.isconditional
IRTools.isreturn
IRTools.returnvalue
IRTools.returntype
IRTools.canbranch
IRTools.explicitbranch!
IRTools.argument!
IRTools.emptyargs!
IRTools.deletearg!
IRTools.block!
IRTools.deleteblock!
IRTools.block
IRTools.blocks
IRTools.branch!
IRTools.return!
IRTools.successors
IRTools.predecessors
IRTools.inline
keys
haskey
push!
pushfirst!
insert!
IRTools.insertafter!
permute!
empty
IRTools.Pipe
```

# IRTools

IRTools provides an IR format with several aims. The idea is to be:

* Expressive enough to represent all parts of Julia's IR pipeline, from lowered code to typed SSA IR;
* Easy to manipulate, like an AST, so that people can do powerful macro-like transformations of code;
* *safe* -- so no segfaults if you misplace an variable somewhere.

Note that before even attempting to understand IRTools, you should have a good handle on Julia's [metaprogramming and macros](https://docs.julialang.org/en/v1/manual/metaprogramming/).

## Reading the IR

### IR Basics

It's easiest to understand the IRTools IR by seeing some examples. We provide the macro `@code_ir` which behaves much like `@code_lowered`.

```jldoctest
julia> using IRTools

julia> f(x) = x+x
f (generic function with 1 method)

julia> @code_ir f(1)
1: (%1, %2)
  %3 = %2 + %2
  return %3
```

First things first. All variables are numbered (`%1`, `%2`, `%3` ...). IR will usually have a _lot_ of these, which is why numbers make more sense than names. At the start of the IR is a list of arguments that are provided as input to the function, `(%1, %2)`. You'll notice there's an extra argument, `%1`, that's ignored here; this represents the function `f` itself, which is used by callable objects and closures.

The main reason that there are a lot of intermediates is that, in IR, we only allow one function call per line. You can see how a nested Julia expression becomes a sequence of single instructions, kind of like an assembly language.

```jldoctest
julia> using IRTools

julia> f(x) = 3x*x + 2x + 1
f (generic function with 1 method)

julia> @code_ir f(1)
1: (%1, %2)
  %3 = 3 * %2
  %4 = %3 * %2
  %5 = 2 * %2
  %6 = %4 + %5 + 1
  return %6
```

While this looks noisy and is at first a little hard to read, it's usually a helpful thing to do. IR is largely designed to be read by programs, rather than by humans, where it's usually easier to look at one instruction at a time.

Beyond that, this is essentially just very verbosely-written Julia code.

### Control Flow

The most significant difference between `IR` and `Expr` is how control flow is handled. There are no such thing as nested if statements, while loops and so on in IR, only *branches*.

```jldoctest
julia> using IRTools

julia> f(x) = x > 0 ? x : 0
f (generic function with 1 method)

julia> @code_ir f(1)
1: (%1, %2)
  %3 = %2 > 0
  br 2 unless %3
  return %2
2:
  return 0
```

The block labels `1:`, `2:` etc and the branch `br 2 unless %3` can be thought of as a version of `@label` and `@goto`. In this case the branch is conditional on the test `%3 = x > 0`; if that's true we'll skip the branch labeled `2` and return `x`.

IR is composed of a series of *basic blocks* that jump between each other like this. A basic block always starts with a label and ends with (optional) branches. No branches can appear in the middle of a basic block; that would just divide the block in two. Any structured control flow, however complex, can be turned into a series of blocks like this.

Here's a more interesting example.

```jldoctest
julia> using IRTools

julia> function f(x)
         if x < 0
           x = -x
         end
         return x
       end
f (generic function with 1 method)

julia> @code_ir f(1)
1: (%1, %2)
  %3 = %2 < 0
  br 3 (%2) unless %3
  br 2
2:
  %4 = -%2
  br 3 (%4)
3: (%5)
  return %5
```

Basic blocks are actually like mini-functions, and they accept a series of arguments. In this case block `3` takes an argument called `%5` that tells it what to return. If you follow the branches as if they were function calls, you'll see that this IR behaves the same as the code we wrote down.

Why not just write this as `%2 = -%2`? It's important to understand that variables in SSA-form IR are *immutable*, in the same sense that variables in functional languages are. For this reason you'll never see a statement like `%2 = %2 + 1`. This again makes analysing IR programmatically a lot easier, because when code uses `%2` you know exactly which definition that refers to.

Loops work this way too: they are visible in the IR by branches that jump backwards, i.e. the `br 2` here. Variables that were modified inside the loop in the original code are explicitly passed between blocks.

```jldoctest envpow
julia> using IRTools

julia> function pow(x, n)
         r = 1
         while n > 0
           n -= 1
           r *= x
         end
         return r
       end
pow (generic function with 1 method)

julia> @code_ir pow(1, 1)
1: (%1, %2, %3)
  br 2 (%3, 1)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
3:
  %7 = %4 - 1
  %8 = %5 * %2
  br 2 (%7, %8)
4:
  return %5
```

## Manipulating IR

### Statements

It's easy to get started by creating an empty fragment of IR.

```jldoctest ir_example
julia> using IRTools: IR, var, argument!, xcall

julia> ir = IR()
1:
```

We can push new statements into the IR. `push!` returns a variable name that we can reuse later on.

```jldoctest ir_example
julia> x = argument!(ir)
%1

julia> x2 = push!(ir, xcall(:*, x, x))
%2

julia> ir
1: (%1)
  %2 = %1 * %1
```

The IR can be viewed as a mapping from variables to statements, and indexing and iteration are consistent with that.

```julia ir_example
julia> ir[var(2)]
IRTools.Statement(:(%1 * %1), Any, 0)

julia> collect(ir)
1-element Array{Any,1}:
 %2 => IRTools.Statement(:(%1 * %1), Any, 0)
```

A `Statement` consists of an expression, a type (usually `Any` unless you're explicitly working with typed IR) and a line number. If you work directly with expressions IRTools will automatically wrap them with `Statement(x)`.

There are a few other functions that do obvious things: `pushfirst!`, `insert!`, `insertafter!`, and `delete!`.

In most cases you won't build IR from scratch, but will start from an existing function and modify its IR.

```jldoctest envpow
julia> ir = @code_ir pow(1, 1)
1: (%1, %2, %3)
  br 2 (%3, 1)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
3:
  %7 = %4 - 1
  %8 = %5 * %2
  br 2 (%7, %8)
4:
  return %5
```

### Blocks

You can work with a block at a time with `block(ir, n)` (all of them with `blocks(ir)`). Blocks similarly support functions like `push!`.

```jldoctest envpow
julia> using IRTools: block

julia> block(ir, 2)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
```

## Evaluating IR

For testing purposes, you can run IR using `IRTools.evalir`.

```jldoctest eval
julia> using IRTools

julia> using IRTools: IR, argument!, return!, xcall, func

julia> ir = IR();

julia> x = argument!(ir);

julia> y = push!(ir, xcall(:*, x, x));

julia> return!(ir, y)
1: (%1)
  %2 = %1 * %1
  return %2

julia> IRTools.evalir(ir, 5)
25
```

More generally, you can turn an IR fragment into an anonymous function, useful
not just for evaluation but also to see the compiler's `@code_typed`,
`@code_llvm` output etc.

```julia
julia> f = func(ir)
##422 (generic function with 1 method)

julia> @code_typed f(5)
CodeInfo(
1 ─ %1 = Base.mul_int(@_2, @_2)::Int64
└──      return %1
) => Int64

julia> @code_llvm f(5)
;  @ /Users/mike/projects/flux/IRTools/src/eval.jl:18 within `##422'
define i64 @"julia_##422_17676"(i64) {
top:
; ┌ @ int.jl:54 within `*'
   %1 = mul i64 %0, %0
   ret i64 %1
; └
}
```

The same works for IR taken from existing functions.

```jldoctest
julia> using IRTools: IR, @code_ir, xcall, func, var

julia> function pow(x, n)
         r = 1
         while n > 0
           n -= 1
           r *= x
         end
         return r
       end
pow (generic function with 1 method)

julia> ir = @code_ir pow(2, 3)
1: (%1, %2, %3)
  br 2 (%3, 1)
2: (%4, %5)
  %6 = %4 > 0
  br 4 unless %6
  br 3
3:
  %7 = %4 - 1
  %8 = %5 * %2
  br 2 (%7, %8)
4:
  return %5


julia> ir[var(8)] = xcall(:+, var(5), var(2))
:(%5 + %2)

julia> mul = func(ir);

julia> mul(nothing, 10, 3)
31
```

# Dynamo

IRTools can be used with metaprogramming tools like [Cassette](https://github.com/jrevels/Cassette.jl), but it also provides a few of its own utilities. The main one is named the "dynamo" after the idea of a "dynamically-scoped macro".

Let me explain. If you write down

```julia
@foo begin
  bar(baz())
end
```

then the `@foo` macro has access to the expression `bar(baz())` and can modify this however it pleases. However, the code of the functions `bar` and `baz` are completely invisible; in more technical terms the macro has lexical extent.

In contrast, a dynamo looks like this:

```julia
foo() do
  bar(baz())
end
```

This can *also* freely modify the `bar(baz())` expression (though it sees it as an `IR` object rather than `Expr`). But more importantly, it can *recurse*, viewing and manipulating the source code of `bar` and `baz` and even any functions *they* call. In other words, it has dynamic extent.

For example, imagine a macro for replacing `*` with `+`:

```julia
julia> using MacroTools

julia> macro foo(ex)
         MacroTools.prewalk(ex) do x
           x == :* ? :+ : x
         end |> esc
       end
@foo (macro with 1 method)

julia> @foo 10*5
15

julia> @foo prod([5, 10])
50
```

The explicit `*` that appears to the macro gets changed, but the implicit one inside `prod` does not. This guide shows you how to do one better.

## A Simple Dynamo

The simplest possible dynamo is a no-op, analagous to the macro

```julia
macro roundtrip(ex)
  esc(ex)
end
```

Here it is:

```jldoctest main
julia> using IRTools: IR, @dynamo

julia> @dynamo roundtrip(a...) = IR(a...)

julia> mul(a, b) = a*b
mul (generic function with 1 method)

julia> roundtrip(mul, 2, 3)
6
```

Here's how it works: our dynamo gets passed a set of *argument types* `a...`. We can use this to get IR for the method being called, with `IR(a...)`. Then we can transform that IR, return it, and it'll be compiled and run as usual.

In this case, we can easily check that the transformed code produced by `roundtrip` is identical to the original IR for `mul`.

```jldoctest main
julia> using IRTools: @code_ir

julia> @code_ir mul(2, 3)
1: (%1, %2, %3)
  %4 = %2 * %3
  return %4

julia> @code_ir roundtrip mul(1, 2)
1: (%1, %2, %3)
  %4 = %2 * %3
  return %4
```

Now we can recreate our `foo` macro. It's a little more verbose since simple symbols like `*` are resolved to `GlobalRef`s in lowered code, but it's broadly the same as our macro.

```@meta
DocTestSetup = quote
    using IRTools
    using IRTools: @dynamo, IR

    mul(a, b) = a * b
end
```

```jldoctest main2
julia> using MacroTools, IRTools

julia> using IRTools: @dynamo, IR

julia> @dynamo function foo(a...)
         ir = IR(a...)
         ir = MacroTools.prewalk(ir) do x
           x isa GlobalRef && x.name == :(*) && return GlobalRef(Base, :+)
           return x
         end
         return ir
       end
```

```@meta
DocTestSetup = nothing
```

It behaves identically, too.

```jldoctest main2
julia> foo() do
         10*5
       end
15

julia> foo() do
         prod([10, 5])
       end
50
```

To get different behaviour we need to *go deeper* – and talk about recursion.

## Recursing

A key difference between macros and dynamos is that dynamos get passed *functions* with they look inside, rather than expressions, so we don't need to write out `mul` when calling `foo(mul, 5, 10)`.

So what if `foo` actually inserted calls to itself when modifying a function? In other words, `prod([1, 2, 3])` would become `foo(prod, [1, 2, 3])`, and so on for each call inside a function. This lets us get the "dynamic extent" property that we talked about earlier.

```jldoctest main2
julia> using IRTools: xcall

julia> @dynamo function foo2(a...)
         ir = IR(a...)
         ir == nothing && return
         ir = MacroTools.prewalk(ir) do x
           x isa GlobalRef && x.name == :(*) && return GlobalRef(Base, :+)
           return x
         end
         for (x, st) in ir
           isexpr(st.expr, :call) || continue
           ir[x] = xcall(foo2, st.expr.args...)
         end
         return ir
       end
```

There are two changes here: firstly, walking over all IR statements to look for, and modify, `call` expressions. Secondly we handle the case where `ir == nothing`, which can happen when we hit things like intrinsic functions for which there is no source code. If we return `nothing`, the dynamo will just run that function as usual.

Check it does the transform we wanted:

```julia
julia> mul_wrapped(a, b) = mul(a, b)
mul_wrapped (generic function with 1 method)

julia> @code_ir mul_wrapped(5, 10)
1: (%1, %2, %3)
  %4 = mul(%2, %3)
  return %4

julia> @code_ir foo2 mul_wrapped(5, 10)
1: (%1, %2, %3)
  %4 = (foo2)(mul, %2, %3)
  return %4
```

And that it works as expected:

```jldoctest main2
julia> foo() do # Does not work (since there is no literal `*` here)
         mul(5, 10)
       end
50

julia> foo2() do # Works correctly
         mul(5, 10)
       end
15

julia> foo2() do
         prod([5, 10])
       end
15
```

This, we have rewritten the `prod` function to actually calculate `sum`, by *internally* rewriting all calls to `*` to instead use `+`.

## Using Dispatch

We can make our `foo2` dynamo simpler in a couple of ways. Firstly, IRTools provides a built-in utility `recurse!` which makes it easy to recurse into code.

```jldoctest main
julia> using MacroTools

julia> using IRTools: recurse!

julia> @dynamo function foo2(a...)
         ir = IR(a...)
         ir == nothing && return
         ir = MacroTools.prewalk(ir) do x
           x isa GlobalRef && x.name == :(*) && return GlobalRef(Base, :+)
           return x
         end
         recurse!(ir)
         return ir
       end

julia> foo2() do
         prod([5, 10])
       end
15
```

Secondly, unlike in a macro, we don't actually need to look through source code for literal references to the `*` function. Because our dynamo is a normal function, we can actually use dispatch to decide what specific functions should do.

```jldoctest main
julia> foo3(::typeof(*), a, b) = a+b
foo3 (generic function with 1 method)

julia> foo3(*, 5, 10)
15
```

Now we can define a simpler version of `foo3` which *only* recurses, and let dispatch figure out when to turn `*`s into `+`s.

```jldoctest main
julia> @dynamo function foo3(a...)
         ir = IR(a...)
         ir == nothing && return
         recurse!(ir)
         return ir
       end

julia> foo3() do
         prod([5, 10])
       end
15
```

## Contexts

We can achieve some interesting things by making our dynamo a *closure*, i.e. a callable object capable of holding some state. For example, consider an object which simply records a count.

```jldoctest counter
julia> mutable struct Counter
         count::Int
       end

julia> Counter() = Counter(0)
Counter

julia> count!(c::Counter) = (c.count += 1)
count! (generic function with 1 method)
```

We can turn this into a dynamo which inserts a single statement into the IR of each function, to increase the count by one.

```jldoctest counter
julia> using IRTools: @dynamo, IR, xcall, self, recurse!

julia> @dynamo function (c::Counter)(m...)
         ir = IR(m...)
         ir == nothing && return
         recurse!(ir)
         pushfirst!(ir, xcall(count!, self))
         return ir
       end
```

Now we can count how many function calls that happen in a given block of code.

```jldoctest counter
julia> c = Counter()
Counter(0)

julia> c() do
         1 + 2.0
       end
3.0

julia> c.count
18
```

!!! warning

    On Julia versions older than 1.3, dynamos are _not_ automatically updated when you redefine functions. For example:

    ```julia
    julia> @dynamo roundtrip(a...) = IR(a...)

    julia> foo(x) = x^2
    foo (generic function with 1 method)

    julia> roundtrip(foo, 5)
    25

    julia> foo(x) = x+1
    foo (generic function with 1 method)

    julia> roundtrip(foo, 5)
    25
    ```

    In order to get the dynamo to see the new definition of `foo`, you can explicitly call `IRTools.refresh()`:

    ```julia
    julia> IRTools.refresh(roundtrip)

    julia> roundtrip(foo, 5)
    6
    ```
    
    With Julia 1.3 and later, `IRTools.refresh` is not required. 
